/* A Bison parser, made by GNU Bison 2.5.  */

/* Bison implementation for Yacc-like parsers in C
   
      Copyright (C) 1984, 1989-1990, 2000-2011 Free Software Foundation, Inc.
   
   This program is free software: you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation, either version 3 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program.  If not, see <http://www.gnu.org/licenses/>.  */

/* As a special exception, you may create a larger work that contains
   part or all of the Bison parser skeleton and distribute that work
   under terms of your choice, so long as that work isn't itself a
   parser generator using the skeleton or a modified version thereof
   as a parser skeleton.  Alternatively, if you modify or redistribute
   the parser skeleton itself, you may (at your option) remove this
   special exception, which will cause the skeleton and the resulting
   Bison output files to be licensed under the GNU General Public
   License without this special exception.
   
   This special exception was added by the Free Software Foundation in
   version 2.2 of Bison.  */

/* C LALR(1) parser skeleton written by Richard Stallman, by
   simplifying the original so-called "semantic" parser.  */

/* All symbols defined below should begin with yy or YY, to avoid
   infringing on user name space.  This should be done even for local
   variables, as they might otherwise be expanded by user macros.
   There are some unavoidable exceptions within include files to
   define necessary library symbols; they are noted "INFRINGES ON
   USER NAME SPACE" below.  */

/* Identify Bison output.  */
#define YYBISON 1

/* Bison version.  */
#define YYBISON_VERSION "2.5"

/* Skeleton name.  */
#define YYSKELETON_NAME "yacc.c"

/* Pure parsers.  */
#define YYPURE 0

/* Push parsers.  */
#define YYPUSH 0

/* Pull parsers.  */
#define YYPULL 1

/* Using locations.  */
#define YYLSP_NEEDED 0



/* Copy the first part of user declarations.  */

/* Line 268 of yacc.c  */
#line 31 "policy_parse.y"

#include <sys/types.h>
#include <assert.h>
#include <stdarg.h>
#include <stdint.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <arpa/inet.h>
#include <stdlib.h>

#include <sepol/policydb/expand.h>
#include <sepol/policydb/policydb.h>
#include <sepol/policydb/services.h>
#include <sepol/policydb/conditional.h>
#include <sepol/policydb/flask.h>
#include <sepol/policydb/hierarchy.h>
#include <sepol/policydb/polcaps.h>
#include "queue.h"
#include "checkpolicy.h"
#include "module_compiler.h"
#include "policy_define.h"

extern policydb_t *policydbp;
extern unsigned int pass;

extern char yytext[];
extern int yylex(void);
extern int yywarn(char *msg);
extern int yyerror(char *msg);

typedef int (* require_func_t)();



/* Line 268 of yacc.c  */
#line 109 "y.tab.c"

/* Enabling traces.  */
#ifndef YYDEBUG
# define YYDEBUG 0
#endif

/* Enabling verbose error messages.  */
#ifdef YYERROR_VERBOSE
# undef YYERROR_VERBOSE
# define YYERROR_VERBOSE 1
#else
# define YYERROR_VERBOSE 0
#endif

/* Enabling the token table.  */
#ifndef YYTOKEN_TABLE
# define YYTOKEN_TABLE 0
#endif


/* Tokens.  */
#ifndef YYTOKENTYPE
# define YYTOKENTYPE
   /* Put the tokens into the symbol table, so that GDB and other debuggers
      know about them.  */
   enum yytokentype {
     PATH = 258,
     FILENAME = 259,
     CLONE = 260,
     COMMON = 261,
     CLASS = 262,
     CONSTRAIN = 263,
     VALIDATETRANS = 264,
     INHERITS = 265,
     SID = 266,
     ROLE = 267,
     ROLEATTRIBUTE = 268,
     ATTRIBUTE_ROLE = 269,
     ROLES = 270,
     TYPEALIAS = 271,
     TYPEATTRIBUTE = 272,
     TYPEBOUNDS = 273,
     TYPE = 274,
     TYPES = 275,
     ALIAS = 276,
     ATTRIBUTE = 277,
     BOOL = 278,
     TUNABLE = 279,
     IF = 280,
     ELSE = 281,
     TYPE_TRANSITION = 282,
     TYPE_MEMBER = 283,
     TYPE_CHANGE = 284,
     ROLE_TRANSITION = 285,
     RANGE_TRANSITION = 286,
     SENSITIVITY = 287,
     DOMINANCE = 288,
     DOM = 289,
     DOMBY = 290,
     INCOMP = 291,
     CATEGORY = 292,
     LEVEL = 293,
     RANGE = 294,
     MLSCONSTRAIN = 295,
     MLSVALIDATETRANS = 296,
     USER = 297,
     NEVERALLOW = 298,
     ALLOW = 299,
     AUDITALLOW = 300,
     AUDITDENY = 301,
     DONTAUDIT = 302,
     SOURCE = 303,
     TARGET = 304,
     SAMEUSER = 305,
     FSCON = 306,
     PORTCON = 307,
     NETIFCON = 308,
     NODECON = 309,
     PIRQCON = 310,
     IOMEMCON = 311,
     IOPORTCON = 312,
     PCIDEVICECON = 313,
     FSUSEXATTR = 314,
     FSUSETASK = 315,
     FSUSETRANS = 316,
     GENFSCON = 317,
     U1 = 318,
     U2 = 319,
     U3 = 320,
     R1 = 321,
     R2 = 322,
     R3 = 323,
     T1 = 324,
     T2 = 325,
     T3 = 326,
     L1 = 327,
     L2 = 328,
     H1 = 329,
     H2 = 330,
     NOT = 331,
     AND = 332,
     OR = 333,
     XOR = 334,
     CTRUE = 335,
     CFALSE = 336,
     IDENTIFIER = 337,
     NUMBER = 338,
     EQUALS = 339,
     NOTEQUAL = 340,
     IPV4_ADDR = 341,
     IPV6_ADDR = 342,
     MODULE = 343,
     VERSION_IDENTIFIER = 344,
     REQUIRE = 345,
     OPTIONAL = 346,
     POLICYCAP = 347,
     PERMISSIVE = 348,
     FILESYSTEM = 349,
     DEFAULT_USER = 350,
     DEFAULT_ROLE = 351,
     DEFAULT_RANGE = 352,
     LOW_HIGH = 353,
     LOW = 354,
     HIGH = 355
   };
#endif
/* Tokens.  */
#define PATH 258
#define FILENAME 259
#define CLONE 260
#define COMMON 261
#define CLASS 262
#define CONSTRAIN 263
#define VALIDATETRANS 264
#define INHERITS 265
#define SID 266
#define ROLE 267
#define ROLEATTRIBUTE 268
#define ATTRIBUTE_ROLE 269
#define ROLES 270
#define TYPEALIAS 271
#define TYPEATTRIBUTE 272
#define TYPEBOUNDS 273
#define TYPE 274
#define TYPES 275
#define ALIAS 276
#define ATTRIBUTE 277
#define BOOL 278
#define TUNABLE 279
#define IF 280
#define ELSE 281
#define TYPE_TRANSITION 282
#define TYPE_MEMBER 283
#define TYPE_CHANGE 284
#define ROLE_TRANSITION 285
#define RANGE_TRANSITION 286
#define SENSITIVITY 287
#define DOMINANCE 288
#define DOM 289
#define DOMBY 290
#define INCOMP 291
#define CATEGORY 292
#define LEVEL 293
#define RANGE 294
#define MLSCONSTRAIN 295
#define MLSVALIDATETRANS 296
#define USER 297
#define NEVERALLOW 298
#define ALLOW 299
#define AUDITALLOW 300
#define AUDITDENY 301
#define DONTAUDIT 302
#define SOURCE 303
#define TARGET 304
#define SAMEUSER 305
#define FSCON 306
#define PORTCON 307
#define NETIFCON 308
#define NODECON 309
#define PIRQCON 310
#define IOMEMCON 311
#define IOPORTCON 312
#define PCIDEVICECON 313
#define FSUSEXATTR 314
#define FSUSETASK 315
#define FSUSETRANS 316
#define GENFSCON 317
#define U1 318
#define U2 319
#define U3 320
#define R1 321
#define R2 322
#define R3 323
#define T1 324
#define T2 325
#define T3 326
#define L1 327
#define L2 328
#define H1 329
#define H2 330
#define NOT 331
#define AND 332
#define OR 333
#define XOR 334
#define CTRUE 335
#define CFALSE 336
#define IDENTIFIER 337
#define NUMBER 338
#define EQUALS 339
#define NOTEQUAL 340
#define IPV4_ADDR 341
#define IPV6_ADDR 342
#define MODULE 343
#define VERSION_IDENTIFIER 344
#define REQUIRE 345
#define OPTIONAL 346
#define POLICYCAP 347
#define PERMISSIVE 348
#define FILESYSTEM 349
#define DEFAULT_USER 350
#define DEFAULT_ROLE 351
#define DEFAULT_RANGE 352
#define LOW_HIGH 353
#define LOW 354
#define HIGH 355




#if ! defined YYSTYPE && ! defined YYSTYPE_IS_DECLARED
typedef union YYSTYPE
{

/* Line 293 of yacc.c  */
#line 68 "policy_parse.y"

	unsigned int val;
	uintptr_t valptr;
	void *ptr;
        require_func_t require_func;



/* Line 293 of yacc.c  */
#line 354 "y.tab.c"
} YYSTYPE;
# define YYSTYPE_IS_TRIVIAL 1
# define yystype YYSTYPE /* obsolescent; will be withdrawn */
# define YYSTYPE_IS_DECLARED 1
#endif


/* Copy the second part of user declarations.  */


/* Line 343 of yacc.c  */
#line 366 "y.tab.c"

#ifdef short
# undef short
#endif

#ifdef YYTYPE_UINT8
typedef YYTYPE_UINT8 yytype_uint8;
#else
typedef unsigned char yytype_uint8;
#endif

#ifdef YYTYPE_INT8
typedef YYTYPE_INT8 yytype_int8;
#elif (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
typedef signed char yytype_int8;
#else
typedef short int yytype_int8;
#endif

#ifdef YYTYPE_UINT16
typedef YYTYPE_UINT16 yytype_uint16;
#else
typedef unsigned short int yytype_uint16;
#endif

#ifdef YYTYPE_INT16
typedef YYTYPE_INT16 yytype_int16;
#else
typedef short int yytype_int16;
#endif

#ifndef YYSIZE_T
# ifdef __SIZE_TYPE__
#  define YYSIZE_T __SIZE_TYPE__
# elif defined size_t
#  define YYSIZE_T size_t
# elif ! defined YYSIZE_T && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#  include <stddef.h> /* INFRINGES ON USER NAME SPACE */
#  define YYSIZE_T size_t
# else
#  define YYSIZE_T unsigned int
# endif
#endif

#define YYSIZE_MAXIMUM ((YYSIZE_T) -1)

#ifndef YY_
# if defined YYENABLE_NLS && YYENABLE_NLS
#  if ENABLE_NLS
#   include <libintl.h> /* INFRINGES ON USER NAME SPACE */
#   define YY_(msgid) dgettext ("bison-runtime", msgid)
#  endif
# endif
# ifndef YY_
#  define YY_(msgid) msgid
# endif
#endif

/* Suppress unused-variable warnings by "using" E.  */
#if ! defined lint || defined __GNUC__
# define YYUSE(e) ((void) (e))
#else
# define YYUSE(e) /* empty */
#endif

/* Identity function, used to suppress warnings about constant conditions.  */
#ifndef lint
# define YYID(n) (n)
#else
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static int
YYID (int yyi)
#else
static int
YYID (yyi)
    int yyi;
#endif
{
  return yyi;
}
#endif

#if ! defined yyoverflow || YYERROR_VERBOSE

/* The parser invokes alloca or malloc; define the necessary symbols.  */

# ifdef YYSTACK_USE_ALLOCA
#  if YYSTACK_USE_ALLOCA
#   ifdef __GNUC__
#    define YYSTACK_ALLOC __builtin_alloca
#   elif defined __BUILTIN_VA_ARG_INCR
#    include <alloca.h> /* INFRINGES ON USER NAME SPACE */
#   elif defined _AIX
#    define YYSTACK_ALLOC __alloca
#   elif defined _MSC_VER
#    include <malloc.h> /* INFRINGES ON USER NAME SPACE */
#    define alloca _alloca
#   else
#    define YYSTACK_ALLOC alloca
#    if ! defined _ALLOCA_H && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
#     include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#     ifndef EXIT_SUCCESS
#      define EXIT_SUCCESS 0
#     endif
#    endif
#   endif
#  endif
# endif

# ifdef YYSTACK_ALLOC
   /* Pacify GCC's `empty if-body' warning.  */
#  define YYSTACK_FREE(Ptr) do { /* empty */; } while (YYID (0))
#  ifndef YYSTACK_ALLOC_MAXIMUM
    /* The OS might guarantee only one guard page at the bottom of the stack,
       and a page size can be as small as 4096 bytes.  So we cannot safely
       invoke alloca (N) if N exceeds 4096.  Use a slightly smaller number
       to allow for a few compiler-allocated temporary stack slots.  */
#   define YYSTACK_ALLOC_MAXIMUM 4032 /* reasonable circa 2006 */
#  endif
# else
#  define YYSTACK_ALLOC YYMALLOC
#  define YYSTACK_FREE YYFREE
#  ifndef YYSTACK_ALLOC_MAXIMUM
#   define YYSTACK_ALLOC_MAXIMUM YYSIZE_MAXIMUM
#  endif
#  if (defined __cplusplus && ! defined EXIT_SUCCESS \
       && ! ((defined YYMALLOC || defined malloc) \
	     && (defined YYFREE || defined free)))
#   include <stdlib.h> /* INFRINGES ON USER NAME SPACE */
#   ifndef EXIT_SUCCESS
#    define EXIT_SUCCESS 0
#   endif
#  endif
#  ifndef YYMALLOC
#   define YYMALLOC malloc
#   if ! defined malloc && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void *malloc (YYSIZE_T); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
#  ifndef YYFREE
#   define YYFREE free
#   if ! defined free && ! defined EXIT_SUCCESS && (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
void free (void *); /* INFRINGES ON USER NAME SPACE */
#   endif
#  endif
# endif
#endif /* ! defined yyoverflow || YYERROR_VERBOSE */


#if (! defined yyoverflow \
     && (! defined __cplusplus \
	 || (defined YYSTYPE_IS_TRIVIAL && YYSTYPE_IS_TRIVIAL)))

/* A type that is properly aligned for any stack member.  */
union yyalloc
{
  yytype_int16 yyss_alloc;
  YYSTYPE yyvs_alloc;
};

/* The size of the maximum gap between one aligned stack and the next.  */
# define YYSTACK_GAP_MAXIMUM (sizeof (union yyalloc) - 1)

/* The size of an array large to enough to hold all stacks, each with
   N elements.  */
# define YYSTACK_BYTES(N) \
     ((N) * (sizeof (yytype_int16) + sizeof (YYSTYPE)) \
      + YYSTACK_GAP_MAXIMUM)

# define YYCOPY_NEEDED 1

/* Relocate STACK from its old location to the new one.  The
   local variables YYSIZE and YYSTACKSIZE give the old and new number of
   elements in the stack, and YYPTR gives the new location of the
   stack.  Advance YYPTR to a properly aligned location for the next
   stack.  */
# define YYSTACK_RELOCATE(Stack_alloc, Stack)				\
    do									\
      {									\
	YYSIZE_T yynewbytes;						\
	YYCOPY (&yyptr->Stack_alloc, Stack, yysize);			\
	Stack = &yyptr->Stack_alloc;					\
	yynewbytes = yystacksize * sizeof (*Stack) + YYSTACK_GAP_MAXIMUM; \
	yyptr += yynewbytes / sizeof (*yyptr);				\
      }									\
    while (YYID (0))

#endif

#if defined YYCOPY_NEEDED && YYCOPY_NEEDED
/* Copy COUNT objects from FROM to TO.  The source and destination do
   not overlap.  */
# ifndef YYCOPY
#  if defined __GNUC__ && 1 < __GNUC__
#   define YYCOPY(To, From, Count) \
      __builtin_memcpy (To, From, (Count) * sizeof (*(From)))
#  else
#   define YYCOPY(To, From, Count)		\
      do					\
	{					\
	  YYSIZE_T yyi;				\
	  for (yyi = 0; yyi < (Count); yyi++)	\
	    (To)[yyi] = (From)[yyi];		\
	}					\
      while (YYID (0))
#  endif
# endif
#endif /* !YYCOPY_NEEDED */

/* YYFINAL -- State number of the termination state.  */
#define YYFINAL  9
/* YYLAST -- Last index in YYTABLE.  */
#define YYLAST   1009

/* YYNTOKENS -- Number of terminals.  */
#define YYNTOKENS  111
/* YYNNTS -- Number of nonterminals.  */
#define YYNNTS  178
/* YYNRULES -- Number of rules.  */
#define YYNRULES  365
/* YYNRULES -- Number of states.  */
#define YYNSTATES  725

/* YYTRANSLATE(YYLEX) -- Bison symbol number corresponding to YYLEX.  */
#define YYUNDEFTOK  2
#define YYMAXUTOK   355

#define YYTRANSLATE(YYX)						\
  ((unsigned int) (YYX) <= YYMAXUTOK ? yytranslate[YYX] : YYUNDEFTOK)

/* YYTRANSLATE[YYLEX] -- Bison symbol number corresponding to YYLEX.  */
static const yytype_uint8 yytranslate[] =
{
       0,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
     106,   107,   110,     2,   105,   108,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,   104,   103,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,   101,     2,   102,   109,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     2,     2,     2,     2,
       2,     2,     2,     2,     2,     2,     1,     2,     3,     4,
       5,     6,     7,     8,     9,    10,    11,    12,    13,    14,
      15,    16,    17,    18,    19,    20,    21,    22,    23,    24,
      25,    26,    27,    28,    29,    30,    31,    32,    33,    34,
      35,    36,    37,    38,    39,    40,    41,    42,    43,    44,
      45,    46,    47,    48,    49,    50,    51,    52,    53,    54,
      55,    56,    57,    58,    59,    60,    61,    62,    63,    64,
      65,    66,    67,    68,    69,    70,    71,    72,    73,    74,
      75,    76,    77,    78,    79,    80,    81,    82,    83,    84,
      85,    86,    87,    88,    89,    90,    91,    92,    93,    94,
      95,    96,    97,    98,    99,   100
};

#if YYDEBUG
/* YYPRHS[YYN] -- Index of the first RHS symbol of rule number YYN in
   YYRHS.  */
static const yytype_uint16 yyprhs[] =
{
       0,     0,     3,     5,     7,     8,     9,    10,    28,    30,
      33,    36,    38,    41,    44,    47,    49,    50,    52,    55,
      61,    63,    66,    72,    77,    85,    87,    88,    90,    92,
      94,    97,   100,   103,   108,   113,   118,   123,   129,   135,
     141,   147,   153,   159,   161,   162,   168,   170,   173,   178,
     182,   185,   188,   193,   195,   196,   198,   201,   206,   210,
     212,   215,   221,   225,   227,   230,   232,   234,   240,   245,
     247,   250,   252,   254,   256,   258,   260,   262,   264,   266,
     268,   270,   272,   274,   276,   278,   280,   282,   284,   286,
     288,   290,   292,   294,   296,   298,   302,   308,   313,   318,
     323,   328,   331,   332,   337,   342,   344,   346,   353,   358,
     359,   363,   366,   370,   374,   378,   382,   386,   388,   390,
     393,   394,   396,   398,   400,   409,   417,   425,   433,   435,
     437,   439,   441,   449,   457,   465,   473,   482,   490,   498,
     506,   512,   520,   522,   524,   526,   528,   530,   538,   546,
     554,   562,   570,   574,   580,   585,   590,   596,   604,   609,
     611,   614,   618,   624,   629,   631,   632,   634,   637,   639,
     641,   647,   652,   656,   659,   663,   667,   669,   673,   677,
     681,   682,   687,   688,   693,   694,   699,   700,   705,   706,
     711,   712,   717,   718,   723,   724,   729,   730,   735,   737,
     738,   743,   744,   749,   752,   753,   758,   759,   764,   768,
     772,   776,   780,   784,   788,   790,   792,   794,   796,   798,
     800,   802,   805,   812,   817,   818,   820,   823,   827,   829,
     830,   832,   835,   837,   839,   841,   843,   847,   851,   857,
     861,   867,   871,   873,   874,   876,   879,   885,   889,   891,
     892,   894,   897,   902,   909,   911,   912,   914,   917,   922,
     924,   925,   927,   930,   935,   940,   942,   943,   945,   948,
     953,   958,   963,   965,   966,   968,   971,   978,   979,   987,
     992,   994,  1001,  1004,  1005,  1009,  1011,  1015,  1017,  1019,
    1023,  1025,  1027,  1029,  1031,  1033,  1036,  1039,  1040,  1045,
    1047,  1049,  1051,  1055,  1057,  1060,  1065,  1067,  1070,  1072,
    1074,  1077,  1081,  1083,  1086,  1088,  1089,  1093,  1095,  1097,
    1099,  1101,  1103,  1105,  1107,  1109,  1113,  1117,  1120,  1125,
    1127,  1129,  1131,  1134,  1137,  1139,  1141,  1143,  1145,  1147,
    1149,  1151,  1156,  1159,  1161,  1164,  1168,  1172,  1174,  1176,
    1178,  1180,  1182,  1184,  1186,  1188,  1190,  1192,  1196,  1197,
    1204,  1209,  1210,  1212,  1214,  1217
};

/* YYRHS -- A `-1'-separated list of the rules' RHS.  */
static const yytype_int16 yyrhs[] =
{
     112,     0,    -1,   113,    -1,   271,    -1,    -1,    -1,    -1,
     114,   117,   119,   121,   115,   127,   132,   147,   211,   189,
     116,   214,   223,   236,   239,   226,   216,    -1,   118,    -1,
     117,   118,    -1,     7,   263,    -1,   120,    -1,   119,   120,
      -1,    11,   263,    -1,   122,   125,    -1,   123,    -1,    -1,
     124,    -1,   123,   124,    -1,     6,   263,   101,   258,   102,
      -1,   126,    -1,   125,   126,    -1,     7,   263,   101,   258,
     102,    -1,     7,   263,    10,   263,    -1,     7,   263,    10,
     263,   101,   258,   102,    -1,   128,    -1,    -1,   129,    -1,
     130,    -1,   131,    -1,   128,   129,    -1,   128,   130,    -1,
     128,   131,    -1,    95,   251,    48,   103,    -1,    95,   251,
      49,   103,    -1,    96,   251,    48,   103,    -1,    96,   251,
      49,   103,    -1,    97,   251,    48,    99,   103,    -1,    97,
     251,    48,   100,   103,    -1,    97,   251,    48,    98,   103,
      -1,    97,   251,    49,    99,   103,    -1,    97,   251,    49,
     100,   103,    -1,    97,   251,    49,    98,   103,    -1,   133,
      -1,    -1,   134,   137,   138,   141,   143,    -1,   135,    -1,
     134,   135,    -1,    32,   263,   136,   103,    -1,    32,   263,
     103,    -1,    21,   251,    -1,    33,   263,    -1,    33,   101,
     258,   102,    -1,   139,    -1,    -1,   140,    -1,   139,   140,
      -1,    37,   263,   136,   103,    -1,    37,   263,   103,    -1,
     142,    -1,   141,   142,    -1,    38,   263,   104,   248,   103,
      -1,    38,   263,   103,    -1,   144,    -1,   143,   144,    -1,
     145,    -1,   146,    -1,    40,   251,   251,   194,   103,    -1,
      41,   251,   194,   103,    -1,   148,    -1,   147,   148,    -1,
     150,    -1,   149,    -1,   160,    -1,   283,    -1,   269,    -1,
     103,    -1,   180,    -1,   181,    -1,   183,    -1,   184,    -1,
     185,    -1,   188,    -1,   182,    -1,   151,    -1,   152,    -1,
     153,    -1,   154,    -1,   155,    -1,   157,    -1,   158,    -1,
     172,    -1,   173,    -1,   174,    -1,   270,    -1,    22,   263,
     103,    -1,    19,   263,   136,   156,   103,    -1,    19,   263,
     156,   103,    -1,    16,   263,   136,   103,    -1,    17,   263,
     248,   103,    -1,    18,   263,   248,   103,    -1,   105,   248,
      -1,    -1,    23,   263,   159,   103,    -1,    24,   263,   159,
     103,    -1,    80,    -1,    81,    -1,    25,   162,   101,   164,
     102,   161,    -1,    26,   101,   164,   102,    -1,    -1,   106,
     162,   107,    -1,    76,   162,    -1,   162,    77,   162,    -1,
     162,    78,   162,    -1,   162,    79,   162,    -1,   162,    84,
     162,    -1,   162,    85,   162,    -1,   163,    -1,   263,    -1,
     164,   165,    -1,    -1,   166,    -1,   167,    -1,   277,    -1,
      27,   251,   251,   104,   251,   263,   266,   103,    -1,    27,
     251,   251,   104,   251,   263,   103,    -1,    28,   251,   251,
     104,   251,   263,   103,    -1,    29,   251,   251,   104,   251,
     263,   103,    -1,   168,    -1,   169,    -1,   170,    -1,   171,
      -1,    44,   251,   251,   104,   251,   251,   103,    -1,    45,
     251,   251,   104,   251,   251,   103,    -1,    46,   251,   251,
     104,   251,   251,   103,    -1,    47,   251,   251,   104,   251,
     251,   103,    -1,    27,   251,   251,   104,   251,   263,   266,
     103,    -1,    27,   251,   251,   104,   251,   263,   103,    -1,
      28,   251,   251,   104,   251,   263,   103,    -1,    29,   251,
     251,   104,   251,   263,   103,    -1,    31,   251,   251,   246,
     103,    -1,    31,   251,   251,   104,   251,   246,   103,    -1,
     175,    -1,   176,    -1,   177,    -1,   178,    -1,   179,    -1,
      44,   251,   251,   104,   251,   251,   103,    -1,    45,   251,
     251,   104,   251,   251,   103,    -1,    46,   251,   251,   104,
     251,   251,   103,    -1,    47,   251,   251,   104,   251,   251,
     103,    -1,    43,   251,   251,   104,   251,   251,   103,    -1,
      14,   263,   103,    -1,    12,   263,    20,   251,   103,    -1,
      12,   263,   156,   103,    -1,    33,   101,   186,   102,    -1,
      30,   251,   251,   263,   103,    -1,    30,   251,   251,   104,
     251,   263,   103,    -1,    44,   251,   251,   103,    -1,   187,
      -1,   186,   187,    -1,    12,   257,   103,    -1,    12,   257,
     101,   186,   102,    -1,    13,   263,   248,   103,    -1,   190,
      -1,    -1,   191,    -1,   190,   191,    -1,   192,    -1,   193,
      -1,     8,   251,   251,   194,   103,    -1,     9,   251,   194,
     103,    -1,   106,   194,   107,    -1,    76,   194,    -1,   194,
      77,   194,    -1,   194,    78,   194,    -1,   195,    -1,    63,
     209,    64,    -1,    66,   210,    67,    -1,    69,   209,    70,
      -1,    -1,    63,   209,   196,   255,    -1,    -1,    64,   209,
     197,   255,    -1,    -1,    65,   209,   198,   255,    -1,    -1,
      66,   209,   199,   255,    -1,    -1,    67,   209,   200,   255,
      -1,    -1,    68,   209,   201,   255,    -1,    -1,    69,   209,
     202,   255,    -1,    -1,    70,   209,   203,   255,    -1,    -1,
      71,   209,   204,   255,    -1,    50,    -1,    -1,    48,    12,
     205,   255,    -1,    -1,    49,    12,   206,   255,    -1,    12,
     210,    -1,    -1,    48,    19,   207,   255,    -1,    -1,    49,
      19,   208,   255,    -1,    72,   210,    73,    -1,    72,   210,
      75,    -1,    74,   210,    73,    -1,    74,   210,    75,    -1,
      72,   210,    74,    -1,    73,   210,    75,    -1,    84,    -1,
      85,    -1,   209,    -1,    34,    -1,    35,    -1,    36,    -1,
     212,    -1,   211,   212,    -1,    42,   263,    15,   251,   213,
     103,    -1,    38,   247,    39,   246,    -1,    -1,   215,    -1,
     214,   215,    -1,    11,   263,   244,    -1,   217,    -1,    -1,
     218,    -1,   217,   218,    -1,   219,    -1,   220,    -1,   221,
      -1,   222,    -1,    55,   267,   244,    -1,    56,   267,   244,
      -1,    56,   267,   108,   267,   244,    -1,    57,   267,   244,
      -1,    57,   267,   108,   267,   244,    -1,    58,   267,   244,
      -1,   224,    -1,    -1,   225,    -1,   224,   225,    -1,    51,
     267,   267,   244,   244,    -1,   227,   230,   233,    -1,   228,
      -1,    -1,   229,    -1,   228,   229,    -1,    52,   263,   267,
     244,    -1,    52,   263,   267,   108,   267,   244,    -1,   231,
      -1,    -1,   232,    -1,   231,   232,    -1,    53,   263,   244,
     244,    -1,   234,    -1,    -1,   235,    -1,   234,   235,    -1,
      54,   243,   243,   244,    -1,    54,   268,   268,   244,    -1,
     237,    -1,    -1,   238,    -1,   237,   238,    -1,    59,   264,
     244,   103,    -1,    60,   263,   244,   103,    -1,    61,   263,
     244,   103,    -1,   240,    -1,    -1,   241,    -1,   240,   241,
      -1,    62,   264,   265,   108,   263,   244,    -1,    -1,    62,
     264,   265,   108,   108,   242,   244,    -1,    62,   264,   265,
     244,    -1,    86,    -1,   263,   104,   263,   104,   263,   245,
      -1,   104,   246,    -1,    -1,   247,   108,   247,    -1,   247,
      -1,   263,   104,   248,    -1,   263,    -1,   263,    -1,   248,
     105,   263,    -1,   109,    -1,   110,    -1,   263,    -1,   259,
      -1,   250,    -1,   249,   263,    -1,   249,   259,    -1,    -1,
     263,   108,   252,   263,    -1,   249,    -1,   250,    -1,   257,
      -1,   101,   256,   102,    -1,   254,    -1,   253,   257,    -1,
     253,   101,   256,   102,    -1,   257,    -1,   256,   257,    -1,
      82,    -1,   263,    -1,   258,   263,    -1,   101,   260,   102,
      -1,   261,    -1,   260,   261,    -1,   263,    -1,    -1,   108,
     262,   263,    -1,   259,    -1,    82,    -1,    94,    -1,    82,
      -1,     3,    -1,     4,    -1,    83,    -1,    87,    -1,    92,
     263,   103,    -1,    93,   263,   103,    -1,   272,   274,    -1,
      88,   263,   273,   103,    -1,    89,    -1,   267,    -1,   243,
      -1,   275,   288,    -1,   275,   276,    -1,   276,    -1,   149,
      -1,   150,    -1,   160,    -1,   277,    -1,   283,    -1,   103,
      -1,    90,   101,   278,   102,    -1,   278,   279,    -1,   279,
      -1,   280,   103,    -1,   281,   282,   103,    -1,     7,   263,
     251,    -1,    12,    -1,    19,    -1,    22,    -1,    14,    -1,
      42,    -1,    23,    -1,    24,    -1,    32,    -1,    37,    -1,
     263,    -1,   282,   105,   263,    -1,    -1,   286,   101,   274,
     102,   284,   285,    -1,   287,   101,   274,   102,    -1,    -1,
      91,    -1,    26,    -1,   212,   288,    -1,    -1
};

/* YYRLINE[YYN] -- source line where rule number YYN was defined.  */
static const yytype_uint16 yyrline[] =
{
       0,   155,   155,   156,   158,   160,   163,   158,   167,   168,
     170,   173,   174,   176,   179,   181,   182,   184,   185,   187,
     190,   191,   193,   195,   197,   200,   201,   203,   204,   205,
     206,   207,   208,   210,   212,   215,   217,   220,   222,   224,
     226,   228,   230,   233,   234,   236,   238,   239,   241,   243,
     246,   248,   250,   253,   254,   256,   257,   259,   261,   264,
     265,   267,   269,   272,   273,   275,   276,   278,   281,   284,
     285,   287,   288,   289,   290,   291,   292,   294,   295,   296,
     297,   298,   299,   300,   302,   303,   304,   305,   306,   307,
     308,   309,   310,   311,   312,   314,   317,   319,   322,   325,
     328,   331,   332,   334,   337,   340,   342,   345,   348,   351,
     352,   354,   357,   360,   363,   366,   369,   372,   375,   379,
     382,   384,   386,   388,   391,   394,   397,   400,   404,   406,
     408,   410,   413,   417,   421,   425,   430,   432,   434,   436,
     439,   441,   444,   445,   446,   447,   448,   450,   453,   456,
     459,   462,   465,   468,   471,   474,   476,   478,   481,   484,
     486,   489,   491,   494,   497,   498,   500,   501,   503,   504,
     506,   509,   512,   514,   517,   520,   523,   526,   529,   532,
     535,   535,   538,   538,   541,   541,   544,   544,   547,   547,
     550,   550,   553,   553,   556,   556,   559,   559,   562,   565,
     565,   568,   568,   571,   574,   574,   577,   577,   580,   583,
     586,   589,   592,   595,   599,   601,   604,   606,   608,   610,
     613,   614,   616,   619,   620,   622,   623,   625,   628,   628,
     630,   631,   633,   634,   635,   636,   638,   641,   643,   646,
     648,   651,   654,   655,   657,   658,   660,   663,   665,   666,
     668,   669,   671,   673,   676,   677,   679,   680,   682,   685,
     686,   688,   689,   691,   693,   696,   697,   699,   700,   702,
     704,   706,   709,   710,   712,   713,   715,   717,   717,   719,
     722,   725,   727,   728,   730,   732,   735,   737,   740,   741,
     743,   745,   747,   749,   751,   754,   757,   760,   760,   763,
     766,   769,   770,   771,   772,   773,   775,   776,   778,   781,
     782,   784,   786,   786,   788,   788,   788,   788,   790,   793,
     795,   798,   801,   804,   807,   810,   813,   818,   823,   826,
     828,   830,   832,   834,   835,   837,   838,   839,   840,   841,
     842,   844,   846,   847,   849,   850,   852,   855,   856,   857,
     858,   859,   860,   861,   862,   863,   865,   867,   871,   870,
     875,   877,   879,   882,   885,   886
};
#endif

#if YYDEBUG || YYERROR_VERBOSE || YYTOKEN_TABLE
/* YYTNAME[SYMBOL-NUM] -- String name of the symbol SYMBOL-NUM.
   First, the terminals, then, starting at YYNTOKENS, nonterminals.  */
static const char *const yytname[] =
{
  "$end", "error", "$undefined", "PATH", "FILENAME", "CLONE", "COMMON",
  "CLASS", "CONSTRAIN", "VALIDATETRANS", "INHERITS", "SID", "ROLE",
  "ROLEATTRIBUTE", "ATTRIBUTE_ROLE", "ROLES", "TYPEALIAS", "TYPEATTRIBUTE",
  "TYPEBOUNDS", "TYPE", "TYPES", "ALIAS", "ATTRIBUTE", "BOOL", "TUNABLE",
  "IF", "ELSE", "TYPE_TRANSITION", "TYPE_MEMBER", "TYPE_CHANGE",
  "ROLE_TRANSITION", "RANGE_TRANSITION", "SENSITIVITY", "DOMINANCE", "DOM",
  "DOMBY", "INCOMP", "CATEGORY", "LEVEL", "RANGE", "MLSCONSTRAIN",
  "MLSVALIDATETRANS", "USER", "NEVERALLOW", "ALLOW", "AUDITALLOW",
  "AUDITDENY", "DONTAUDIT", "SOURCE", "TARGET", "SAMEUSER", "FSCON",
  "PORTCON", "NETIFCON", "NODECON", "PIRQCON", "IOMEMCON", "IOPORTCON",
  "PCIDEVICECON", "FSUSEXATTR", "FSUSETASK", "FSUSETRANS", "GENFSCON",
  "U1", "U2", "U3", "R1", "R2", "R3", "T1", "T2", "T3", "L1", "L2", "H1",
  "H2", "NOT", "AND", "OR", "XOR", "CTRUE", "CFALSE", "IDENTIFIER",
  "NUMBER", "EQUALS", "NOTEQUAL", "IPV4_ADDR", "IPV6_ADDR", "MODULE",
  "VERSION_IDENTIFIER", "REQUIRE", "OPTIONAL", "POLICYCAP", "PERMISSIVE",
  "FILESYSTEM", "DEFAULT_USER", "DEFAULT_ROLE", "DEFAULT_RANGE",
  "LOW_HIGH", "LOW", "HIGH", "'{'", "'}'", "';'", "':'", "','", "'('",
  "')'", "'-'", "'~'", "'*'", "$accept", "policy", "base_policy", "$@1",
  "$@2", "$@3", "classes", "class_def", "initial_sids", "initial_sid_def",
  "access_vectors", "opt_common_perms", "common_perms", "common_perms_def",
  "av_perms", "av_perms_def", "opt_default_rules", "default_rules",
  "default_user_def", "default_role_def", "default_range_def", "opt_mls",
  "mls", "sensitivities", "sensitivity_def", "alias_def", "dominance",
  "opt_categories", "categories", "category_def", "levels", "level_def",
  "mlspolicy", "mlspolicy_decl", "mlsconstraint_def",
  "mlsvalidatetrans_def", "te_rbac", "te_rbac_decl", "rbac_decl",
  "te_decl", "attribute_def", "type_def", "typealias_def",
  "typeattribute_def", "typebounds_def", "opt_attr_list", "bool_def",
  "tunable_def", "bool_val", "cond_stmt_def", "cond_else", "cond_expr",
  "cond_expr_prim", "cond_pol_list", "cond_rule_def",
  "cond_transition_def", "cond_te_avtab_def", "cond_allow_def",
  "cond_auditallow_def", "cond_auditdeny_def", "cond_dontaudit_def",
  "transition_def", "range_trans_def", "te_avtab_def", "allow_def",
  "auditallow_def", "auditdeny_def", "dontaudit_def", "neverallow_def",
  "attribute_role_def", "role_type_def", "role_attr_def", "role_dominance",
  "role_trans_def", "role_allow_def", "roles", "role_def",
  "roleattribute_def", "opt_constraints", "constraints", "constraint_decl",
  "constraint_def", "validatetrans_def", "cexpr", "cexpr_prim", "$@4",
  "$@5", "$@6", "$@7", "$@8", "$@9", "$@10", "$@11", "$@12", "$@13",
  "$@14", "$@15", "$@16", "op", "role_mls_op", "users", "user_def",
  "opt_mls_user", "initial_sid_contexts", "initial_sid_context_def",
  "opt_dev_contexts", "dev_contexts", "dev_context_def",
  "pirq_context_def", "iomem_context_def", "ioport_context_def",
  "pci_context_def", "opt_fs_contexts", "fs_contexts", "fs_context_def",
  "net_contexts", "opt_port_contexts", "port_contexts", "port_context_def",
  "opt_netif_contexts", "netif_contexts", "netif_context_def",
  "opt_node_contexts", "node_contexts", "node_context_def", "opt_fs_uses",
  "fs_uses", "fs_use_def", "opt_genfs_contexts", "genfs_contexts",
  "genfs_context_def", "$@17", "ipv4_addr_def", "security_context_def",
  "opt_mls_range_def", "mls_range_def", "mls_level_def", "id_comma_list",
  "tilde", "asterisk", "names", "$@18", "tilde_push", "asterisk_push",
  "names_push", "identifier_list_push", "identifier_push",
  "identifier_list", "nested_id_set", "nested_id_list",
  "nested_id_element", "$@19", "identifier", "filesystem", "path",
  "filename", "number", "ipv6_addr", "policycap_def", "permissive_def",
  "module_policy", "module_def", "version_identifier", "avrules_block",
  "avrule_decls", "avrule_decl", "require_block", "require_list",
  "require_decl", "require_class", "require_decl_def", "require_id_list",
  "optional_block", "$@20", "optional_else", "optional_decl", "else_decl",
  "avrule_user_defs", 0
};
#endif

# ifdef YYPRINT
/* YYTOKNUM[YYLEX-NUM] -- Internal token number corresponding to
   token YYLEX-NUM.  */
static const yytype_uint16 yytoknum[] =
{
       0,   256,   257,   258,   259,   260,   261,   262,   263,   264,
     265,   266,   267,   268,   269,   270,   271,   272,   273,   274,
     275,   276,   277,   278,   279,   280,   281,   282,   283,   284,
     285,   286,   287,   288,   289,   290,   291,   292,   293,   294,
     295,   296,   297,   298,   299,   300,   301,   302,   303,   304,
     305,   306,   307,   308,   309,   310,   311,   312,   313,   314,
     315,   316,   317,   318,   319,   320,   321,   322,   323,   324,
     325,   326,   327,   328,   329,   330,   331,   332,   333,   334,
     335,   336,   337,   338,   339,   340,   341,   342,   343,   344,
     345,   346,   347,   348,   349,   350,   351,   352,   353,   354,
     355,   123,   125,    59,    58,    44,    40,    41,    45,   126,
      42
};
# endif

/* YYR1[YYN] -- Symbol number of symbol that rule YYN derives.  */
static const yytype_uint16 yyr1[] =
{
       0,   111,   112,   112,   114,   115,   116,   113,   117,   117,
     118,   119,   119,   120,   121,   122,   122,   123,   123,   124,
     125,   125,   126,   126,   126,   127,   127,   128,   128,   128,
     128,   128,   128,   129,   129,   130,   130,   131,   131,   131,
     131,   131,   131,   132,   132,   133,   134,   134,   135,   135,
     136,   137,   137,   138,   138,   139,   139,   140,   140,   141,
     141,   142,   142,   143,   143,   144,   144,   145,   146,   147,
     147,   148,   148,   148,   148,   148,   148,   149,   149,   149,
     149,   149,   149,   149,   150,   150,   150,   150,   150,   150,
     150,   150,   150,   150,   150,   151,   152,   152,   153,   154,
     155,   156,   156,   157,   158,   159,   159,   160,   161,   161,
     162,   162,   162,   162,   162,   162,   162,   162,   163,   164,
     164,   165,   165,   165,   166,   166,   166,   166,   167,   167,
     167,   167,   168,   169,   170,   171,   172,   172,   172,   172,
     173,   173,   174,   174,   174,   174,   174,   175,   176,   177,
     178,   179,   180,   181,   182,   183,   184,   184,   185,   186,
     186,   187,   187,   188,   189,   189,   190,   190,   191,   191,
     192,   193,   194,   194,   194,   194,   194,   195,   195,   195,
     196,   195,   197,   195,   198,   195,   199,   195,   200,   195,
     201,   195,   202,   195,   203,   195,   204,   195,   195,   205,
     195,   206,   195,   195,   207,   195,   208,   195,   195,   195,
     195,   195,   195,   195,   209,   209,   210,   210,   210,   210,
     211,   211,   212,   213,   213,   214,   214,   215,   216,   216,
     217,   217,   218,   218,   218,   218,   219,   220,   220,   221,
     221,   222,   223,   223,   224,   224,   225,   226,   227,   227,
     228,   228,   229,   229,   230,   230,   231,   231,   232,   233,
     233,   234,   234,   235,   235,   236,   236,   237,   237,   238,
     238,   238,   239,   239,   240,   240,   241,   242,   241,   241,
     243,   244,   245,   245,   246,   246,   247,   247,   248,   248,
     249,   250,   251,   251,   251,   251,   251,   252,   251,   253,
     254,   255,   255,   255,   255,   255,   256,   256,   257,   258,
     258,   259,   260,   260,   261,   262,   261,   261,   263,   264,
     264,   265,   266,   267,   268,   269,   270,   271,   272,   273,
     273,   273,   274,   275,   275,   276,   276,   276,   276,   276,
     276,   277,   278,   278,   279,   279,   280,   281,   281,   281,
     281,   281,   281,   281,   281,   281,   282,   282,   284,   283,
     285,   285,   286,   287,   288,   288
};

/* YYR2[YYN] -- Number of symbols composing right hand side of rule YYN.  */
static const yytype_uint8 yyr2[] =
{
       0,     2,     1,     1,     0,     0,     0,    17,     1,     2,
       2,     1,     2,     2,     2,     1,     0,     1,     2,     5,
       1,     2,     5,     4,     7,     1,     0,     1,     1,     1,
       2,     2,     2,     4,     4,     4,     4,     5,     5,     5,
       5,     5,     5,     1,     0,     5,     1,     2,     4,     3,
       2,     2,     4,     1,     0,     1,     2,     4,     3,     1,
       2,     5,     3,     1,     2,     1,     1,     5,     4,     1,
       2,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     1,     1,     1,
       1,     1,     1,     1,     1,     3,     5,     4,     4,     4,
       4,     2,     0,     4,     4,     1,     1,     6,     4,     0,
       3,     2,     3,     3,     3,     3,     3,     1,     1,     2,
       0,     1,     1,     1,     8,     7,     7,     7,     1,     1,
       1,     1,     7,     7,     7,     7,     8,     7,     7,     7,
       5,     7,     1,     1,     1,     1,     1,     7,     7,     7,
       7,     7,     3,     5,     4,     4,     5,     7,     4,     1,
       2,     3,     5,     4,     1,     0,     1,     2,     1,     1,
       5,     4,     3,     2,     3,     3,     1,     3,     3,     3,
       0,     4,     0,     4,     0,     4,     0,     4,     0,     4,
       0,     4,     0,     4,     0,     4,     0,     4,     1,     0,
       4,     0,     4,     2,     0,     4,     0,     4,     3,     3,
       3,     3,     3,     3,     1,     1,     1,     1,     1,     1,
       1,     2,     6,     4,     0,     1,     2,     3,     1,     0,
       1,     2,     1,     1,     1,     1,     3,     3,     5,     3,
       5,     3,     1,     0,     1,     2,     5,     3,     1,     0,
       1,     2,     4,     6,     1,     0,     1,     2,     4,     1,
       0,     1,     2,     4,     4,     1,     0,     1,     2,     4,
       4,     4,     1,     0,     1,     2,     6,     0,     7,     4,
       1,     6,     2,     0,     3,     1,     3,     1,     1,     3,
       1,     1,     1,     1,     1,     2,     2,     0,     4,     1,
       1,     1,     3,     1,     2,     4,     1,     2,     1,     1,
       2,     3,     1,     2,     1,     0,     3,     1,     1,     1,
       1,     1,     1,     1,     1,     3,     3,     2,     4,     1,
       1,     1,     2,     2,     1,     1,     1,     1,     1,     1,
       1,     4,     2,     1,     2,     3,     3,     1,     1,     1,
       1,     1,     1,     1,     1,     1,     1,     3,     0,     6,
       4,     0,     1,     1,     2,     0
};

/* YYDEFACT[STATE-NAME] -- Default reduction number in state STATE-NUM.
   Performed when YYTABLE doesn't specify something else to do.  Zero
   means the default is an error.  */
static const yytype_uint16 yydefact[] =
{
       4,     0,     0,     2,     0,     3,     0,   318,     0,     1,
       0,     0,     8,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   362,     0,   340,   335,
     336,    84,    85,    86,    87,    88,    89,    90,   337,    91,
      92,    93,   142,   143,   144,   145,   146,    77,    78,    83,
      79,    80,    81,    82,    94,   327,   365,   334,   338,   339,
       0,   323,   280,   329,   331,   330,     0,    10,     0,     9,
      16,    11,   102,     0,     0,     0,     0,     0,   102,     0,
       0,     0,     0,     0,     0,   117,   118,     0,   290,   291,
       0,   294,     0,   293,   292,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,   365,   333,
     332,     0,   328,    13,     0,    12,     5,     0,    15,    17,
       0,     0,     0,     0,   288,   152,     0,     0,     0,     0,
     102,     0,    95,   105,   106,     0,     0,   111,     0,     0,
       0,     0,     0,     0,   120,   315,   317,     0,   312,   314,
     296,   295,     0,   297,     0,     0,     0,     0,     0,     0,
     159,     0,     0,     0,     0,     0,     0,   347,   350,   348,
     349,   352,   353,   354,   355,   351,     0,   343,     0,     0,
     326,     0,   364,     0,     0,    26,     0,    14,    20,    18,
       0,   101,   154,   163,     0,    50,    98,    99,   100,     0,
      97,   103,   104,   110,   112,   113,   114,   115,   116,     0,
       0,   311,   313,     0,     0,     0,     0,     0,     0,     0,
       0,   285,   287,   308,     0,   155,   160,     0,   158,     0,
       0,     0,     0,     0,   341,   342,   344,   356,     0,     0,
     358,     0,     0,     0,     0,    44,    25,    27,    28,    29,
       0,    21,   153,   289,    96,     0,     0,     0,     0,     0,
       0,     0,   109,   119,   121,   122,   128,   129,   130,   131,
     123,   316,     0,   298,     0,     0,     0,   156,     0,   140,
       0,     0,     0,   161,     0,     0,     0,     0,     0,   346,
     345,     0,   224,   361,     0,   309,     0,     0,     0,     0,
       0,    43,     0,    46,    30,    31,    32,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,   107,     0,     0,
       0,     0,     0,   284,   286,     0,     0,     0,     0,     0,
       0,   357,     0,     0,   363,   359,     0,    19,   310,     0,
       0,     0,     0,     0,     0,     0,     0,    76,     0,    69,
      72,    71,    73,    75,    74,     0,    47,    54,    23,     0,
       0,     0,     0,     0,     0,     0,     0,   120,   322,   137,
       0,   138,   139,   157,   141,   162,   151,   147,   148,   149,
     150,     0,   222,     0,    33,    34,    35,    36,     0,     0,
       0,     0,     0,     0,    49,     0,     0,    70,   165,   220,
       0,    51,     0,     0,    53,    55,     0,    22,     0,     0,
       0,     0,     0,     0,     0,     0,   136,     0,     0,    39,
      37,    38,    42,    40,    41,    48,   325,     0,     0,     6,
     164,   166,   168,   169,   221,     0,     0,     0,     0,    59,
      56,     0,     0,     0,     0,     0,     0,     0,     0,   108,
     223,   360,     0,     0,     0,   167,    52,    58,     0,     0,
       0,     0,    60,    45,    63,    65,    66,    24,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   198,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,   176,     0,   243,   225,    57,
      62,     0,     0,     0,    64,   125,     0,   126,   127,   132,
     133,   134,   135,     0,   217,   218,   219,   214,   215,   216,
     203,   199,   204,   201,   206,   180,   182,   184,   186,     0,
     188,   190,   192,   194,   196,     0,     0,     0,   173,     0,
       0,     0,   171,     0,     0,   226,   266,   242,   244,     0,
       0,     0,   124,   170,     0,     0,     0,     0,   177,     0,
       0,     0,     0,   178,     0,     0,   179,     0,     0,     0,
     208,   212,   209,   213,   210,   211,   172,   174,   175,   227,
       0,     0,     0,     0,     0,   273,   265,   267,   245,    61,
       0,    68,     0,   299,   300,     0,   303,   200,   301,   205,
     202,   207,   181,   183,   185,   187,   189,   191,   193,   195,
     197,     0,     0,   320,   319,     0,     0,     0,     0,   249,
     272,   274,   268,    67,     0,   306,     0,   304,     0,     0,
       0,     0,     0,     0,     0,   229,   255,   248,   250,   275,
     302,   307,     0,     0,   246,   269,   270,   271,   321,     0,
       0,     0,     0,     0,     0,     7,   228,   230,   232,   233,
     234,   235,     0,   260,   254,   256,   251,   305,   283,     0,
     279,     0,     0,     0,     0,     0,   231,     0,     0,   247,
     259,   261,   257,     0,   281,   277,     0,     0,   252,   236,
       0,   237,     0,   239,   241,     0,   324,     0,     0,   262,
     282,     0,   276,     0,     0,     0,   258,     0,     0,   278,
     253,   238,   240,   263,   264
};

/* YYDEFGOTO[NTERM-NUM].  */
static const yytype_int16 yydefgoto[] =
{
      -1,     2,     3,     4,   195,   464,    11,    12,    80,    81,
     126,   127,   128,   129,   197,   198,   255,   256,   257,   258,
     259,   310,   311,   312,   313,   137,   367,   413,   414,   415,
     448,   449,   473,   474,   475,   476,   358,   359,    39,    40,
      41,    42,    43,    44,    45,   132,    46,    47,   145,    48,
     327,    94,    95,   219,   273,   274,   275,   276,   277,   278,
     279,    49,    50,    51,    52,    53,    54,    55,    56,    57,
      58,    59,    60,    61,    62,   169,   170,    63,   439,   440,
     441,   442,   443,   504,   505,   569,   570,   571,   572,   574,
     575,   577,   578,   579,   564,   566,   565,   567,   529,   530,
     408,   118,   343,   507,   508,   665,   666,   667,   668,   669,
     670,   671,   556,   557,   558,   645,   646,   647,   648,   673,
     674,   675,   689,   690,   691,   595,   596,   597,   629,   630,
     631,   711,    74,   589,   694,   230,   231,   133,   100,   101,
     102,   224,   605,   606,   607,   634,   608,   304,   103,   157,
     158,   220,   104,   625,   659,   380,    75,   708,   363,    64,
       5,     6,    76,    65,    66,    67,    68,   186,   187,   188,
     189,   248,    69,   303,   345,    70,   346,   120
};

/* YYPACT[STATE-NUM] -- Index in YYTABLE of the portion describing
   STATE-NUM.  */
#define YYPACT_NINF -544
static const yytype_int16 yypact[] =
{
     -33,   -14,    97,  -544,   151,  -544,   757,  -544,   224,  -544,
     -14,   136,  -544,   -14,   -14,   -14,   -14,   -14,   -14,   -14,
     -14,   -14,   -14,    56,   100,   100,   100,   100,   100,    69,
     100,   100,   100,   100,   100,    91,  -544,   -14,  -544,  -544,
    -544,  -544,  -544,  -544,  -544,  -544,  -544,  -544,  -544,  -544,
    -544,  -544,  -544,  -544,  -544,  -544,  -544,  -544,  -544,  -544,
    -544,  -544,  -544,  -544,  -544,  -544,   375,  -544,  -544,  -544,
     107,  -544,  -544,  -544,  -544,  -544,   123,  -544,   -14,  -544,
     291,  -544,     5,   -14,   152,   248,   -14,   -14,     7,   198,
     185,   185,    56,    56,   214,  -544,  -544,    52,  -544,  -544,
     138,  -544,   100,  -544,   206,   100,   100,   100,   100,   306,
     100,   100,   100,   100,   100,   324,   257,   -14,   321,  -544,
    -544,   757,  -544,  -544,   -14,  -544,  -544,   360,   367,  -544,
     100,   -14,   275,   177,  -544,  -544,   100,   278,   234,   237,
     285,   298,  -544,  -544,  -544,   304,   313,    95,    99,    56,
      56,    56,    56,    56,  -544,  -544,  -544,   116,  -544,  -544,
    -544,  -544,   332,  -544,   341,   345,   -29,    60,   390,    25,
    -544,   371,   241,   372,   373,   376,   -14,  -544,  -544,  -544,
    -544,  -544,  -544,  -544,  -544,  -544,    27,  -544,   378,   -14,
    -544,   464,  -544,   388,   395,   238,   -14,   360,  -544,  -544,
     399,   401,  -544,  -544,   -14,  -544,  -544,  -544,  -544,   404,
    -544,  -544,  -544,  -544,    95,   164,   193,  -544,  -544,    34,
     -14,  -544,  -544,   100,   -14,   100,   100,   100,   405,   100,
     406,   383,   400,  -544,   101,  -544,  -544,   100,  -544,   100,
     100,   100,   100,   100,  -544,  -544,  -544,  -544,   328,   100,
    -544,   -14,   100,   100,   100,   479,   238,  -544,  -544,  -544,
      14,  -544,  -544,  -544,  -544,   100,   100,   100,   100,   100,
     100,   100,   492,  -544,  -544,  -544,  -544,  -544,  -544,  -544,
    -544,  -544,   -14,  -544,   -14,   -14,   -14,  -544,   -14,  -544,
     -14,   -14,   306,  -544,   100,   100,   100,   100,   100,  -544,
    -544,   -14,   481,   494,    44,  -544,   305,   337,   347,   -14,
     811,  -544,   408,  -544,  -544,  -544,  -544,   -14,   -14,   100,
     100,   100,   100,   100,   100,   100,   420,  -544,     6,   433,
     438,   441,   445,  -544,   401,    26,   446,   447,   448,   450,
     451,  -544,   -14,   452,  -544,  -544,   425,  -544,  -544,   453,
     454,   455,   456,   259,   314,     8,   -14,  -544,   470,  -544,
    -544,  -544,  -544,  -544,  -544,   171,  -544,   523,   463,   109,
     472,   476,   477,   478,   480,   482,   483,  -544,  -544,  -544,
     465,  -544,  -544,  -544,  -544,  -544,  -544,  -544,  -544,  -544,
    -544,   544,  -544,   757,  -544,  -544,  -544,  -544,   485,   486,
     487,   488,   491,   493,  -544,   495,   498,  -544,    65,  -544,
     -14,  -544,   -14,   547,   523,  -544,   -14,  -544,   100,   100,
     100,   100,   100,   100,   100,    43,  -544,   -14,   504,  -544,
    -544,  -544,  -544,  -544,  -544,  -544,  -544,   100,   100,  -544,
     434,  -544,  -544,  -544,  -544,   114,    10,   -14,   271,  -544,
    -544,   150,   -14,   -14,   -14,   100,   100,   100,   100,  -544,
    -544,  -544,   100,   256,   584,  -544,  -544,  -544,   509,   344,
     100,   100,  -544,   423,  -544,  -544,  -544,  -544,    19,   510,
     511,   512,   513,   514,   515,   256,   105,    86,   267,  -544,
     386,   386,   386,   105,   386,   386,   386,   386,   386,   105,
     105,   105,   256,   256,   122,  -544,   -14,    16,  -544,  -544,
    -544,   -14,   100,   256,  -544,  -544,   516,  -544,  -544,  -544,
    -544,  -544,  -544,   137,  -544,  -544,  -544,  -544,  -544,  -544,
    -544,  -544,  -544,  -544,  -544,   533,  -544,  -544,   555,   556,
    -544,  -544,   530,  -544,  -544,   350,   553,   359,  -544,   -12,
     256,   256,  -544,   -14,   546,  -544,   369,   579,  -544,   334,
     256,   159,  -544,  -544,   112,   112,   112,   112,  -544,   112,
     112,   112,   112,  -544,   112,   112,  -544,   112,   112,   112,
    -544,  -544,  -544,  -544,  -544,  -544,  -544,  -544,   554,  -544,
     528,   546,   -42,   -14,   -14,   572,   369,  -544,  -544,  -544,
     168,  -544,   390,  -544,  -544,   172,  -544,  -544,  -544,  -544,
    -544,  -544,  -544,  -544,  -544,  -544,  -544,  -544,  -544,  -544,
    -544,   -14,   -14,  -544,  -544,   -14,   -14,   -14,   -42,   583,
     572,  -544,  -544,  -544,   156,  -544,   390,  -544,   532,   -14,
     534,   536,   537,   638,   -14,   294,   589,   583,  -544,  -544,
    -544,  -544,   165,   -14,  -544,  -544,  -544,  -544,  -544,   -52,
     546,   546,   546,   546,   546,  -544,   294,  -544,  -544,  -544,
    -544,  -544,   -14,   590,   589,  -544,  -544,  -544,   541,    53,
    -544,    55,   -14,    73,    85,   -14,  -544,   -14,   387,  -544,
     590,  -544,  -544,   -14,  -544,  -544,   -14,   546,  -544,  -544,
     546,  -544,   546,  -544,  -544,   -14,  -544,   560,   561,  -544,
    -544,   -14,  -544,   -14,   -14,   -14,  -544,   -14,   -14,  -544,
    -544,  -544,  -544,  -544,  -544
};

/* YYPGOTO[NTERM-NUM].  */
static const yytype_int16 yypgoto[] =
{
    -544,  -544,  -544,  -544,  -544,  -544,  -544,   636,  -544,   569,
    -544,  -544,  -544,   522,  -544,   457,  -544,  -544,   397,   403,
     407,  -544,  -544,  -544,   339,   -81,  -544,  -544,  -544,   242,
    -544,   207,  -544,   184,  -544,  -544,  -544,   302,  -275,  -265,
    -544,  -544,  -544,  -544,  -544,   -56,  -544,  -544,   570,  -252,
    -544,   -49,  -544,   287,  -544,  -544,  -544,  -544,  -544,  -544,
    -544,  -544,  -544,  -544,  -544,  -544,  -544,  -544,  -544,  -544,
    -544,  -544,  -544,  -544,  -544,   370,  -161,  -544,  -544,  -544,
     225,  -544,  -544,  -316,  -544,  -544,  -544,  -544,  -544,  -544,
    -544,  -544,  -544,  -544,  -544,  -544,  -544,  -544,   -36,  -205,
    -544,  -332,  -544,  -544,   160,  -544,  -544,     2,  -544,  -544,
    -544,  -544,  -544,  -544,   113,  -544,  -544,  -544,    22,  -544,
    -544,    -8,  -544,  -544,   -18,  -544,  -544,    77,  -544,  -544,
      45,  -544,  -432,  -454,  -544,  -283,  -248,   -84,  -195,   -32,
     497,  -544,  -544,  -544,     0,    38,  -167,  -285,   -43,  -544,
     519,  -544,    -1,    49,  -544,   201,  -543,   -23,  -544,  -544,
    -544,  -544,  -544,  -117,  -544,   621,  -213,  -544,   502,  -544,
    -544,  -544,  -250,  -544,  -544,  -544,  -544,   571
};

/* YYTABLE[YYPACT[STATE-NUM]].  What to do in state STATE-NUM.  If
   positive, shift that token.  If negative, reduce the rule which
   number is the opposite.  If YYTABLE_NINF, syntax error.  */
#define YYTABLE_NINF -217
static const yytype_int16 yytable[] =
{
       8,   234,   138,   139,   193,   332,   280,   140,   236,    77,
     378,   591,    82,    83,    84,    85,    86,    87,    88,    89,
      90,    91,    96,   378,   317,   130,   409,   506,   136,   136,
       7,   136,   141,   369,   176,   360,   116,   168,   168,   177,
     623,   178,   333,   147,   148,   361,   179,   201,   622,   180,
     181,   182,   624,     7,   156,     1,   679,   160,   362,   183,
     364,   265,   266,   267,   184,   550,   551,   554,     7,   185,
     265,   266,   267,   437,   438,   227,   444,   123,   268,   269,
     270,   271,   134,   360,   209,   134,   134,   268,   269,   270,
     271,    96,    96,   361,   391,   586,   159,     9,   531,   161,
     214,   215,   216,   217,   218,   532,   362,   117,   364,   379,
     131,   404,   131,   467,   156,   318,   191,   681,   682,   683,
     684,   685,   515,   194,    35,   445,     7,   235,   385,   244,
     134,   451,    92,    35,     7,     7,   272,     7,     7,   524,
     525,   526,     7,    10,   460,   459,   347,    78,    96,    96,
      96,    96,    96,    97,   713,     7,   159,   714,    10,   715,
     155,   695,    93,   697,   229,   228,   232,     7,   639,   523,
     109,   640,   641,   642,   236,   243,   149,   150,   151,   152,
     153,   700,     7,   152,   153,   654,   548,   549,   247,   527,
     528,     7,   115,   702,   233,   260,     7,   561,     7,   550,
     551,    97,   292,   263,   293,   680,   213,   334,   121,    98,
      99,   417,   280,   602,   550,   551,   466,    97,   221,   281,
       7,    98,    99,   283,   155,   552,   122,   698,   699,   701,
     703,   704,     7,   705,   587,   588,   550,   551,   233,    97,
     563,   149,   712,   151,   600,   550,   551,   233,   152,   153,
     305,   716,   477,     7,   233,   135,   707,   719,   650,   720,
     721,   722,   601,   723,   724,   143,   144,   677,   486,   136,
     149,   633,   410,   636,   405,   717,   428,   152,   153,   533,
     203,   328,   204,   329,   330,   331,   534,   232,   539,   232,
     134,   149,   150,   151,   545,   546,   547,   124,   152,   153,
     341,   142,    78,   348,   487,   488,   489,    71,   355,   447,
      72,   470,   471,    73,   163,   154,   368,   305,   168,   490,
     491,   492,   493,   494,   495,   496,   497,   498,   499,   500,
     501,   176,   502,   252,   253,   254,   177,   207,   178,   204,
     208,   232,   204,   179,   238,   239,   180,   181,   182,   661,
     662,   663,   664,   349,   350,   406,   183,   398,   399,   400,
     190,   184,   503,   117,   411,   468,   185,   196,   348,   603,
     603,   603,   603,   124,   603,   603,   603,   603,   202,   603,
     603,   206,   603,   603,   603,   351,   352,    13,    14,    15,
     131,    16,    17,    18,    19,   353,   354,    20,    21,    22,
      23,   210,    24,    25,    26,    27,    28,   211,    29,   305,
     710,   446,   401,   402,   403,   305,   212,   117,    30,    31,
      32,    33,    34,   580,   581,   582,   232,   559,   592,   593,
     594,   300,   584,   301,   585,   635,   223,   599,   637,   204,
     309,   365,   437,   438,   348,   225,   469,   510,   511,   226,
     348,   478,   479,   480,   535,   536,   537,   538,   540,   541,
     542,   543,   544,   470,   471,    35,    36,   651,    37,   635,
     527,   528,   233,    72,   706,   237,   240,   241,    38,   249,
     242,   246,    13,    14,    15,   651,    16,    17,    18,    19,
     250,   290,    20,    21,    22,    23,   251,    24,    25,    26,
      27,    28,   262,    29,   291,   553,   204,   264,   287,   289,
     134,   309,   117,    30,    31,    32,    33,    34,   326,   342,
     344,   377,   105,   106,   107,   108,   393,   110,   111,   112,
     113,   114,   604,   604,   604,   604,   381,   604,   604,   604,
     604,   382,   604,   604,   383,   604,   604,   604,   384,   386,
     387,   388,   590,   389,   390,   392,   394,   395,   396,   397,
     412,    36,   356,    37,   416,   609,   610,   611,   426,   612,
     613,   614,   615,   357,   616,   617,   418,   618,   619,   620,
     419,   420,   421,   427,   422,   447,   423,   424,   429,   430,
     431,   432,   626,   627,   433,   506,   434,   568,   435,   162,
     576,   436,   164,   165,   166,   167,   461,   171,   172,   173,
     174,   175,   509,   517,   518,   519,   520,   521,   522,   562,
     638,   590,  -216,   573,   590,   590,   590,   200,   583,    71,
     554,   550,   621,   205,   628,   644,   653,   655,   590,   656,
     657,   658,   672,   660,   688,   693,    72,    79,   706,   125,
     199,   366,   678,   314,   261,   472,   450,   514,   590,   315,
     407,   146,   335,   316,   425,   465,   692,   555,   686,   676,
     598,   687,   709,   632,   652,   649,   222,   643,   696,   516,
     590,   590,   590,   590,   590,   718,   590,   119,   245,   192,
       0,     0,   232,     0,     0,   590,     0,     0,     0,     0,
       0,     0,     0,     0,   590,     0,     0,     0,     0,     0,
     590,     0,   590,   590,   590,     0,   590,   590,     0,     0,
     282,     0,   284,   285,   286,     0,   288,     0,     0,     0,
       0,     0,     0,     0,   294,     0,   295,   296,   297,   298,
     299,     0,     0,     0,     0,     0,   302,     0,     0,   306,
     307,   308,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   319,   320,   321,   322,   323,   324,   325,    13,
      14,    15,     0,    16,    17,    18,    19,     0,     0,    20,
      21,    22,    23,     0,    24,    25,    26,    27,    28,     0,
      29,   336,   337,   338,   339,   340,     0,     0,     0,     0,
      30,    31,    32,    33,    34,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,   370,   371,   372,   373,
     374,   375,   376,    13,    14,    15,     0,    16,    17,    18,
      19,     0,     0,    20,    21,    22,    23,     0,    24,    25,
      26,    27,    28,     0,    29,     0,     0,    35,    36,     0,
      37,     0,     0,     0,    30,    31,    32,    33,    34,     0,
      38,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,    36,   356,    37,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   357,   452,   453,   454,   455,   456,
     457,   458,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,   462,   463,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,   481,   482,   483,   484,     0,     0,     0,   485,
       0,     0,     0,     0,     0,     0,     0,   512,   513,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,     0,
       0,     0,     0,     0,     0,     0,     0,     0,     0,   560
};

#define yypact_value_is_default(yystate) \
  ((yystate) == (-544))

#define yytable_value_is_error(yytable_value) \
  YYID (0)

static const yytype_int16 yycheck[] =
{
       1,   168,    86,    87,   121,   288,   219,    88,   169,    10,
       4,   554,    13,    14,    15,    16,    17,    18,    19,    20,
      21,    22,    23,     4,    10,    20,   358,    11,    21,    21,
      82,    21,    88,   318,     7,   310,    37,    12,    12,    12,
      82,    14,   290,    92,    93,   310,    19,   131,   591,    22,
      23,    24,    94,    82,    97,    88,   108,   100,   310,    32,
     310,    27,    28,    29,    37,    77,    78,    51,    82,    42,
      27,    28,    29,     8,     9,   104,   408,    78,    44,    45,
      46,    47,    83,   358,   140,    86,    87,    44,    45,    46,
      47,    92,    93,   358,   342,   107,    97,     0,    12,   100,
     149,   150,   151,   152,   153,    19,   358,    42,   358,   103,
     105,   103,   105,   103,   157,   101,   117,   660,   661,   662,
     663,   664,   103,   124,    90,   410,    82,   102,   102,   102,
     131,   416,    76,    90,    82,    82,   102,    82,    82,    34,
      35,    36,    82,     7,   427,   102,   102,    11,   149,   150,
     151,   152,   153,   101,   697,    82,   157,   700,     7,   702,
     108,   108,   106,   108,   104,   166,   167,    82,   622,   485,
     101,   625,   626,   627,   335,   176,    77,    78,    79,    84,
      85,   108,    82,    84,    85,   639,   502,   503,   189,    84,
      85,    82,   101,   108,    82,   196,    82,   513,    82,    77,
      78,   101,   101,   204,   103,   659,   107,   291,   101,   109,
     110,   102,   425,   101,    77,    78,   102,   101,   102,   220,
      82,   109,   110,   224,   108,   103,   103,   681,   682,   683,
     684,   685,    82,   687,   550,   551,    77,    78,    82,   101,
     103,    77,   696,    79,   560,    77,    78,    82,    84,    85,
     251,   705,   102,    82,    82,   103,   688,   711,   102,   713,
     714,   715,   103,   717,   718,    80,    81,   102,    12,    21,
      77,   103,   101,   101,   355,   707,   393,    84,    85,    12,
     103,   282,   105,   284,   285,   286,    19,   288,   493,   290,
     291,    77,    78,    79,   499,   500,   501,     6,    84,    85,
     301,   103,    11,   304,    48,    49,    50,    83,   309,    38,
      86,    40,    41,    89,   108,   101,   317,   318,    12,    63,
      64,    65,    66,    67,    68,    69,    70,    71,    72,    73,
      74,     7,    76,    95,    96,    97,    12,   103,    14,   105,
     103,   342,   105,    19,   103,   104,    22,    23,    24,    55,
      56,    57,    58,    48,    49,   356,    32,    98,    99,   100,
     103,    37,   106,    42,   365,   446,    42,     7,   369,   564,
     565,   566,   567,     6,   569,   570,   571,   572,   103,   574,
     575,   103,   577,   578,   579,    48,    49,    12,    13,    14,
     105,    16,    17,    18,    19,    48,    49,    22,    23,    24,
      25,   103,    27,    28,    29,    30,    31,   103,    33,   410,
     693,   412,    98,    99,   100,   416,   103,    42,    43,    44,
      45,    46,    47,    73,    74,    75,   427,   511,    59,    60,
      61,   103,    73,   105,    75,   602,   104,   103,   605,   105,
      32,    33,     8,     9,   445,   104,   447,   103,   104,   104,
     451,   452,   453,   454,   490,   491,   492,   493,   494,   495,
     496,   497,   498,    40,    41,    90,    91,   634,    93,   636,
      84,    85,    82,    86,    87,   104,   104,   104,   103,    15,
     104,   103,    12,    13,    14,   652,    16,    17,    18,    19,
     102,   108,    22,    23,    24,    25,   101,    27,    28,    29,
      30,    31,   103,    33,   104,   506,   105,   103,   103,   103,
     511,    32,    42,    43,    44,    45,    46,    47,    26,    38,
      26,   101,    25,    26,    27,    28,   101,    30,    31,    32,
      33,    34,   564,   565,   566,   567,   103,   569,   570,   571,
     572,   103,   574,   575,   103,   577,   578,   579,   103,   103,
     103,   103,   553,   103,   103,   103,   103,   103,   103,   103,
      37,    91,    92,    93,   101,   565,   566,   567,   103,   569,
     570,   571,   572,   103,   574,   575,   104,   577,   578,   579,
     104,   104,   104,    39,   104,    38,   104,   104,   103,   103,
     103,   103,   593,   594,   103,    11,   103,    64,   103,   102,
      70,   103,   105,   106,   107,   108,   102,   110,   111,   112,
     113,   114,   103,   103,   103,   103,   103,   103,   103,   103,
     621,   622,    67,    67,   625,   626,   627,   130,    75,    83,
      51,    77,   104,   136,    62,    52,   104,   103,   639,   103,
     103,     3,    53,   644,    54,   104,    86,    11,    87,    80,
     128,   312,   653,   256,   197,   448,   414,   473,   659,   256,
     358,    91,   292,   256,   377,   440,   674,   507,   666,   647,
     557,   672,   690,   596,   636,   630,   157,   628,   679,   478,
     681,   682,   683,   684,   685,   708,   687,    66,   186,   118,
      -1,    -1,   693,    -1,    -1,   696,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   705,    -1,    -1,    -1,    -1,    -1,
     711,    -1,   713,   714,   715,    -1,   717,   718,    -1,    -1,
     223,    -1,   225,   226,   227,    -1,   229,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   237,    -1,   239,   240,   241,   242,
     243,    -1,    -1,    -1,    -1,    -1,   249,    -1,    -1,   252,
     253,   254,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   265,   266,   267,   268,   269,   270,   271,    12,
      13,    14,    -1,    16,    17,    18,    19,    -1,    -1,    22,
      23,    24,    25,    -1,    27,    28,    29,    30,    31,    -1,
      33,   294,   295,   296,   297,   298,    -1,    -1,    -1,    -1,
      43,    44,    45,    46,    47,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,   319,   320,   321,   322,
     323,   324,   325,    12,    13,    14,    -1,    16,    17,    18,
      19,    -1,    -1,    22,    23,    24,    25,    -1,    27,    28,
      29,    30,    31,    -1,    33,    -1,    -1,    90,    91,    -1,
      93,    -1,    -1,    -1,    43,    44,    45,    46,    47,    -1,
     103,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    91,    92,    93,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   103,   418,   419,   420,   421,   422,
     423,   424,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,   437,   438,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,   455,   456,   457,   458,    -1,    -1,    -1,   462,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,   470,   471,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,
      -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,    -1,   512
};

/* YYSTOS[STATE-NUM] -- The (internal number of the) accessing
   symbol of state STATE-NUM.  */
static const yytype_uint16 yystos[] =
{
       0,    88,   112,   113,   114,   271,   272,    82,   263,     0,
       7,   117,   118,    12,    13,    14,    16,    17,    18,    19,
      22,    23,    24,    25,    27,    28,    29,    30,    31,    33,
      43,    44,    45,    46,    47,    90,    91,    93,   103,   149,
     150,   151,   152,   153,   154,   155,   157,   158,   160,   172,
     173,   174,   175,   176,   177,   178,   179,   180,   181,   182,
     183,   184,   185,   188,   270,   274,   275,   276,   277,   283,
     286,    83,    86,    89,   243,   267,   273,   263,    11,   118,
     119,   120,   263,   263,   263,   263,   263,   263,   263,   263,
     263,   263,    76,   106,   162,   163,   263,   101,   109,   110,
     249,   250,   251,   259,   263,   251,   251,   251,   251,   101,
     251,   251,   251,   251,   251,   101,   263,    42,   212,   276,
     288,   101,   103,   263,     6,   120,   121,   122,   123,   124,
      20,   105,   156,   248,   263,   103,    21,   136,   248,   248,
     136,   156,   103,    80,    81,   159,   159,   162,   162,    77,
      78,    79,    84,    85,   101,   108,   259,   260,   261,   263,
     259,   263,   251,   108,   251,   251,   251,   251,    12,   186,
     187,   251,   251,   251,   251,   251,     7,    12,    14,    19,
      22,    23,    24,    32,    37,    42,   278,   279,   280,   281,
     103,   263,   288,   274,   263,   115,     7,   125,   126,   124,
     251,   248,   103,   103,   105,   251,   103,   103,   103,   156,
     103,   103,   103,   107,   162,   162,   162,   162,   162,   164,
     262,   102,   261,   104,   252,   104,   104,   104,   263,   104,
     246,   247,   263,    82,   257,   102,   187,   104,   103,   104,
     104,   104,   104,   263,   102,   279,   103,   263,   282,    15,
     102,   101,    95,    96,    97,   127,   128,   129,   130,   131,
     263,   126,   103,   263,   103,    27,    28,    29,    44,    45,
      46,    47,   102,   165,   166,   167,   168,   169,   170,   171,
     277,   263,   251,   263,   251,   251,   251,   103,   251,   103,
     108,   104,   101,   103,   251,   251,   251,   251,   251,   251,
     103,   105,   251,   284,   258,   263,   251,   251,   251,    32,
     132,   133,   134,   135,   129,   130,   131,    10,   101,   251,
     251,   251,   251,   251,   251,   251,    26,   161,   263,   263,
     263,   263,   246,   247,   248,   186,   251,   251,   251,   251,
     251,   263,    38,   213,    26,   285,   287,   102,   263,    48,
      49,    48,    49,    48,    49,   263,    92,   103,   147,   148,
     149,   150,   160,   269,   283,    33,   135,   137,   263,   258,
     251,   251,   251,   251,   251,   251,   251,   101,     4,   103,
     266,   103,   103,   103,   103,   102,   103,   103,   103,   103,
     103,   247,   103,   101,   103,   103,   103,   103,    98,    99,
     100,    98,    99,   100,   103,   136,   263,   148,   211,   212,
     101,   263,    37,   138,   139,   140,   101,   102,   104,   104,
     104,   104,   104,   104,   104,   164,   103,    39,   274,   103,
     103,   103,   103,   103,   103,   103,   103,     8,     9,   189,
     190,   191,   192,   193,   212,   258,   263,    38,   141,   142,
     140,   258,   251,   251,   251,   251,   251,   251,   251,   102,
     246,   102,   251,   251,   116,   191,   102,   103,   136,   263,
      40,    41,   142,   143,   144,   145,   146,   102,   263,   263,
     263,   251,   251,   251,   251,   251,    12,    48,    49,    50,
      63,    64,    65,    66,    67,    68,    69,    70,    71,    72,
      73,    74,    76,   106,   194,   195,    11,   214,   215,   103,
     103,   104,   251,   251,   144,   103,   266,   103,   103,   103,
     103,   103,   103,   194,    34,    35,    36,    84,    85,   209,
     210,    12,    19,    12,    19,   209,   209,   209,   209,   210,
     209,   209,   209,   209,   209,   210,   210,   210,   194,   194,
      77,    78,   103,   263,    51,   215,   223,   224,   225,   248,
     251,   194,   103,   103,   205,   207,   206,   208,    64,   196,
     197,   198,   199,    67,   200,   201,    70,   202,   203,   204,
      73,    74,    75,    75,    73,    75,   107,   194,   194,   244,
     263,   267,    59,    60,    61,   236,   237,   238,   225,   103,
     194,   103,   101,   249,   250,   253,   254,   255,   257,   255,
     255,   255,   255,   255,   255,   255,   255,   255,   255,   255,
     255,   104,   267,    82,    94,   264,   263,   263,    62,   239,
     240,   241,   238,   103,   256,   257,   101,   257,   263,   244,
     244,   244,   244,   264,    52,   226,   227,   228,   229,   241,
     102,   257,   256,   104,   244,   103,   103,   103,     3,   265,
     263,    55,    56,    57,    58,   216,   217,   218,   219,   220,
     221,   222,    53,   230,   231,   232,   229,   102,   263,   108,
     244,   267,   267,   267,   267,   267,   218,   263,    54,   233,
     234,   235,   232,   104,   245,   108,   263,   108,   244,   244,
     108,   244,   108,   244,   244,   244,    87,   243,   268,   235,
     246,   242,   244,   267,   267,   267,   244,   243,   268,   244,
     244,   244,   244,   244,   244
};

#define yyerrok		(yyerrstatus = 0)
#define yyclearin	(yychar = YYEMPTY)
#define YYEMPTY		(-2)
#define YYEOF		0

#define YYACCEPT	goto yyacceptlab
#define YYABORT		goto yyabortlab
#define YYERROR		goto yyerrorlab


/* Like YYERROR except do call yyerror.  This remains here temporarily
   to ease the transition to the new meaning of YYERROR, for GCC.
   Once GCC version 2 has supplanted version 1, this can go.  However,
   YYFAIL appears to be in use.  Nevertheless, it is formally deprecated
   in Bison 2.4.2's NEWS entry, where a plan to phase it out is
   discussed.  */

#define YYFAIL		goto yyerrlab
#if defined YYFAIL
  /* This is here to suppress warnings from the GCC cpp's
     -Wunused-macros.  Normally we don't worry about that warning, but
     some users do, and we want to make it easy for users to remove
     YYFAIL uses, which will produce warnings from Bison 2.5.  */
#endif

#define YYRECOVERING()  (!!yyerrstatus)

#define YYBACKUP(Token, Value)					\
do								\
  if (yychar == YYEMPTY && yylen == 1)				\
    {								\
      yychar = (Token);						\
      yylval = (Value);						\
      YYPOPSTACK (1);						\
      goto yybackup;						\
    }								\
  else								\
    {								\
      yyerror (YY_("syntax error: cannot back up")); \
      YYERROR;							\
    }								\
while (YYID (0))


#define YYTERROR	1
#define YYERRCODE	256


/* YYLLOC_DEFAULT -- Set CURRENT to span from RHS[1] to RHS[N].
   If N is 0, then set CURRENT to the empty location which ends
   the previous symbol: RHS[0] (always defined).  */

#define YYRHSLOC(Rhs, K) ((Rhs)[K])
#ifndef YYLLOC_DEFAULT
# define YYLLOC_DEFAULT(Current, Rhs, N)				\
    do									\
      if (YYID (N))                                                    \
	{								\
	  (Current).first_line   = YYRHSLOC (Rhs, 1).first_line;	\
	  (Current).first_column = YYRHSLOC (Rhs, 1).first_column;	\
	  (Current).last_line    = YYRHSLOC (Rhs, N).last_line;		\
	  (Current).last_column  = YYRHSLOC (Rhs, N).last_column;	\
	}								\
      else								\
	{								\
	  (Current).first_line   = (Current).last_line   =		\
	    YYRHSLOC (Rhs, 0).last_line;				\
	  (Current).first_column = (Current).last_column =		\
	    YYRHSLOC (Rhs, 0).last_column;				\
	}								\
    while (YYID (0))
#endif


/* This macro is provided for backward compatibility. */

#ifndef YY_LOCATION_PRINT
# define YY_LOCATION_PRINT(File, Loc) ((void) 0)
#endif


/* YYLEX -- calling `yylex' with the right arguments.  */

#ifdef YYLEX_PARAM
# define YYLEX yylex (YYLEX_PARAM)
#else
# define YYLEX yylex ()
#endif

/* Enable debugging if requested.  */
#if YYDEBUG

# ifndef YYFPRINTF
#  include <stdio.h> /* INFRINGES ON USER NAME SPACE */
#  define YYFPRINTF fprintf
# endif

# define YYDPRINTF(Args)			\
do {						\
  if (yydebug)					\
    YYFPRINTF Args;				\
} while (YYID (0))

# define YY_SYMBOL_PRINT(Title, Type, Value, Location)			  \
do {									  \
  if (yydebug)								  \
    {									  \
      YYFPRINTF (stderr, "%s ", Title);					  \
      yy_symbol_print (stderr,						  \
		  Type, Value); \
      YYFPRINTF (stderr, "\n");						  \
    }									  \
} while (YYID (0))


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_value_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_value_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (!yyvaluep)
    return;
# ifdef YYPRINT
  if (yytype < YYNTOKENS)
    YYPRINT (yyoutput, yytoknum[yytype], *yyvaluep);
# else
  YYUSE (yyoutput);
# endif
  switch (yytype)
    {
      default:
	break;
    }
}


/*--------------------------------.
| Print this symbol on YYOUTPUT.  |
`--------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_symbol_print (FILE *yyoutput, int yytype, YYSTYPE const * const yyvaluep)
#else
static void
yy_symbol_print (yyoutput, yytype, yyvaluep)
    FILE *yyoutput;
    int yytype;
    YYSTYPE const * const yyvaluep;
#endif
{
  if (yytype < YYNTOKENS)
    YYFPRINTF (yyoutput, "token %s (", yytname[yytype]);
  else
    YYFPRINTF (yyoutput, "nterm %s (", yytname[yytype]);

  yy_symbol_value_print (yyoutput, yytype, yyvaluep);
  YYFPRINTF (yyoutput, ")");
}

/*------------------------------------------------------------------.
| yy_stack_print -- Print the state stack from its BOTTOM up to its |
| TOP (included).                                                   |
`------------------------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_stack_print (yytype_int16 *yybottom, yytype_int16 *yytop)
#else
static void
yy_stack_print (yybottom, yytop)
    yytype_int16 *yybottom;
    yytype_int16 *yytop;
#endif
{
  YYFPRINTF (stderr, "Stack now");
  for (; yybottom <= yytop; yybottom++)
    {
      int yybot = *yybottom;
      YYFPRINTF (stderr, " %d", yybot);
    }
  YYFPRINTF (stderr, "\n");
}

# define YY_STACK_PRINT(Bottom, Top)				\
do {								\
  if (yydebug)							\
    yy_stack_print ((Bottom), (Top));				\
} while (YYID (0))


/*------------------------------------------------.
| Report that the YYRULE is going to be reduced.  |
`------------------------------------------------*/

#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yy_reduce_print (YYSTYPE *yyvsp, int yyrule)
#else
static void
yy_reduce_print (yyvsp, yyrule)
    YYSTYPE *yyvsp;
    int yyrule;
#endif
{
  int yynrhs = yyr2[yyrule];
  int yyi;
  unsigned long int yylno = yyrline[yyrule];
  YYFPRINTF (stderr, "Reducing stack by rule %d (line %lu):\n",
	     yyrule - 1, yylno);
  /* The symbols being reduced.  */
  for (yyi = 0; yyi < yynrhs; yyi++)
    {
      YYFPRINTF (stderr, "   $%d = ", yyi + 1);
      yy_symbol_print (stderr, yyrhs[yyprhs[yyrule] + yyi],
		       &(yyvsp[(yyi + 1) - (yynrhs)])
		       		       );
      YYFPRINTF (stderr, "\n");
    }
}

# define YY_REDUCE_PRINT(Rule)		\
do {					\
  if (yydebug)				\
    yy_reduce_print (yyvsp, Rule); \
} while (YYID (0))

/* Nonzero means print parse trace.  It is left uninitialized so that
   multiple parsers can coexist.  */
int yydebug;
#else /* !YYDEBUG */
# define YYDPRINTF(Args)
# define YY_SYMBOL_PRINT(Title, Type, Value, Location)
# define YY_STACK_PRINT(Bottom, Top)
# define YY_REDUCE_PRINT(Rule)
#endif /* !YYDEBUG */


/* YYINITDEPTH -- initial size of the parser's stacks.  */
#ifndef	YYINITDEPTH
# define YYINITDEPTH 200
#endif

/* YYMAXDEPTH -- maximum size the stacks can grow to (effective only
   if the built-in stack extension method is used).

   Do not make this value too large; the results are undefined if
   YYSTACK_ALLOC_MAXIMUM < YYSTACK_BYTES (YYMAXDEPTH)
   evaluated with infinite-precision integer arithmetic.  */

#ifndef YYMAXDEPTH
# define YYMAXDEPTH 10000
#endif


#if YYERROR_VERBOSE

# ifndef yystrlen
#  if defined __GLIBC__ && defined _STRING_H
#   define yystrlen strlen
#  else
/* Return the length of YYSTR.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static YYSIZE_T
yystrlen (const char *yystr)
#else
static YYSIZE_T
yystrlen (yystr)
    const char *yystr;
#endif
{
  YYSIZE_T yylen;
  for (yylen = 0; yystr[yylen]; yylen++)
    continue;
  return yylen;
}
#  endif
# endif

# ifndef yystpcpy
#  if defined __GLIBC__ && defined _STRING_H && defined _GNU_SOURCE
#   define yystpcpy stpcpy
#  else
/* Copy YYSRC to YYDEST, returning the address of the terminating '\0' in
   YYDEST.  */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static char *
yystpcpy (char *yydest, const char *yysrc)
#else
static char *
yystpcpy (yydest, yysrc)
    char *yydest;
    const char *yysrc;
#endif
{
  char *yyd = yydest;
  const char *yys = yysrc;

  while ((*yyd++ = *yys++) != '\0')
    continue;

  return yyd - 1;
}
#  endif
# endif

# ifndef yytnamerr
/* Copy to YYRES the contents of YYSTR after stripping away unnecessary
   quotes and backslashes, so that it's suitable for yyerror.  The
   heuristic is that double-quoting is unnecessary unless the string
   contains an apostrophe, a comma, or backslash (other than
   backslash-backslash).  YYSTR is taken from yytname.  If YYRES is
   null, do not copy; instead, return the length of what the result
   would have been.  */
static YYSIZE_T
yytnamerr (char *yyres, const char *yystr)
{
  if (*yystr == '"')
    {
      YYSIZE_T yyn = 0;
      char const *yyp = yystr;

      for (;;)
	switch (*++yyp)
	  {
	  case '\'':
	  case ',':
	    goto do_not_strip_quotes;

	  case '\\':
	    if (*++yyp != '\\')
	      goto do_not_strip_quotes;
	    /* Fall through.  */
	  default:
	    if (yyres)
	      yyres[yyn] = *yyp;
	    yyn++;
	    break;

	  case '"':
	    if (yyres)
	      yyres[yyn] = '\0';
	    return yyn;
	  }
    do_not_strip_quotes: ;
    }

  if (! yyres)
    return yystrlen (yystr);

  return yystpcpy (yyres, yystr) - yyres;
}
# endif

/* Copy into *YYMSG, which is of size *YYMSG_ALLOC, an error message
   about the unexpected token YYTOKEN for the state stack whose top is
   YYSSP.

   Return 0 if *YYMSG was successfully written.  Return 1 if *YYMSG is
   not large enough to hold the message.  In that case, also set
   *YYMSG_ALLOC to the required number of bytes.  Return 2 if the
   required number of bytes is too large to store.  */
static int
yysyntax_error (YYSIZE_T *yymsg_alloc, char **yymsg,
                yytype_int16 *yyssp, int yytoken)
{
  YYSIZE_T yysize0 = yytnamerr (0, yytname[yytoken]);
  YYSIZE_T yysize = yysize0;
  YYSIZE_T yysize1;
  enum { YYERROR_VERBOSE_ARGS_MAXIMUM = 5 };
  /* Internationalized format string. */
  const char *yyformat = 0;
  /* Arguments of yyformat. */
  char const *yyarg[YYERROR_VERBOSE_ARGS_MAXIMUM];
  /* Number of reported tokens (one for the "unexpected", one per
     "expected"). */
  int yycount = 0;

  /* There are many possibilities here to consider:
     - Assume YYFAIL is not used.  It's too flawed to consider.  See
       <http://lists.gnu.org/archive/html/bison-patches/2009-12/msg00024.html>
       for details.  YYERROR is fine as it does not invoke this
       function.
     - If this state is a consistent state with a default action, then
       the only way this function was invoked is if the default action
       is an error action.  In that case, don't check for expected
       tokens because there are none.
     - The only way there can be no lookahead present (in yychar) is if
       this state is a consistent state with a default action.  Thus,
       detecting the absence of a lookahead is sufficient to determine
       that there is no unexpected or expected token to report.  In that
       case, just report a simple "syntax error".
     - Don't assume there isn't a lookahead just because this state is a
       consistent state with a default action.  There might have been a
       previous inconsistent state, consistent state with a non-default
       action, or user semantic action that manipulated yychar.
     - Of course, the expected token list depends on states to have
       correct lookahead information, and it depends on the parser not
       to perform extra reductions after fetching a lookahead from the
       scanner and before detecting a syntax error.  Thus, state merging
       (from LALR or IELR) and default reductions corrupt the expected
       token list.  However, the list is correct for canonical LR with
       one exception: it will still contain any token that will not be
       accepted due to an error action in a later state.
  */
  if (yytoken != YYEMPTY)
    {
      int yyn = yypact[*yyssp];
      yyarg[yycount++] = yytname[yytoken];
      if (!yypact_value_is_default (yyn))
        {
          /* Start YYX at -YYN if negative to avoid negative indexes in
             YYCHECK.  In other words, skip the first -YYN actions for
             this state because they are default actions.  */
          int yyxbegin = yyn < 0 ? -yyn : 0;
          /* Stay within bounds of both yycheck and yytname.  */
          int yychecklim = YYLAST - yyn + 1;
          int yyxend = yychecklim < YYNTOKENS ? yychecklim : YYNTOKENS;
          int yyx;

          for (yyx = yyxbegin; yyx < yyxend; ++yyx)
            if (yycheck[yyx + yyn] == yyx && yyx != YYTERROR
                && !yytable_value_is_error (yytable[yyx + yyn]))
              {
                if (yycount == YYERROR_VERBOSE_ARGS_MAXIMUM)
                  {
                    yycount = 1;
                    yysize = yysize0;
                    break;
                  }
                yyarg[yycount++] = yytname[yyx];
                yysize1 = yysize + yytnamerr (0, yytname[yyx]);
                if (! (yysize <= yysize1
                       && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
                  return 2;
                yysize = yysize1;
              }
        }
    }

  switch (yycount)
    {
# define YYCASE_(N, S)                      \
      case N:                               \
        yyformat = S;                       \
      break
      YYCASE_(0, YY_("syntax error"));
      YYCASE_(1, YY_("syntax error, unexpected %s"));
      YYCASE_(2, YY_("syntax error, unexpected %s, expecting %s"));
      YYCASE_(3, YY_("syntax error, unexpected %s, expecting %s or %s"));
      YYCASE_(4, YY_("syntax error, unexpected %s, expecting %s or %s or %s"));
      YYCASE_(5, YY_("syntax error, unexpected %s, expecting %s or %s or %s or %s"));
# undef YYCASE_
    }

  yysize1 = yysize + yystrlen (yyformat);
  if (! (yysize <= yysize1 && yysize1 <= YYSTACK_ALLOC_MAXIMUM))
    return 2;
  yysize = yysize1;

  if (*yymsg_alloc < yysize)
    {
      *yymsg_alloc = 2 * yysize;
      if (! (yysize <= *yymsg_alloc
             && *yymsg_alloc <= YYSTACK_ALLOC_MAXIMUM))
        *yymsg_alloc = YYSTACK_ALLOC_MAXIMUM;
      return 1;
    }

  /* Avoid sprintf, as that infringes on the user's name space.
     Don't have undefined behavior even if the translation
     produced a string with the wrong number of "%s"s.  */
  {
    char *yyp = *yymsg;
    int yyi = 0;
    while ((*yyp = *yyformat) != '\0')
      if (*yyp == '%' && yyformat[1] == 's' && yyi < yycount)
        {
          yyp += yytnamerr (yyp, yyarg[yyi++]);
          yyformat += 2;
        }
      else
        {
          yyp++;
          yyformat++;
        }
  }
  return 0;
}
#endif /* YYERROR_VERBOSE */

/*-----------------------------------------------.
| Release the memory associated to this symbol.  |
`-----------------------------------------------*/

/*ARGSUSED*/
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
static void
yydestruct (const char *yymsg, int yytype, YYSTYPE *yyvaluep)
#else
static void
yydestruct (yymsg, yytype, yyvaluep)
    const char *yymsg;
    int yytype;
    YYSTYPE *yyvaluep;
#endif
{
  YYUSE (yyvaluep);

  if (!yymsg)
    yymsg = "Deleting";
  YY_SYMBOL_PRINT (yymsg, yytype, yyvaluep, yylocationp);

  switch (yytype)
    {

      default:
	break;
    }
}


/* Prevent warnings from -Wmissing-prototypes.  */
#ifdef YYPARSE_PARAM
#if defined __STDC__ || defined __cplusplus
int yyparse (void *YYPARSE_PARAM);
#else
int yyparse ();
#endif
#else /* ! YYPARSE_PARAM */
#if defined __STDC__ || defined __cplusplus
int yyparse (void);
#else
int yyparse ();
#endif
#endif /* ! YYPARSE_PARAM */


/* The lookahead symbol.  */
int yychar;

/* The semantic value of the lookahead symbol.  */
YYSTYPE yylval;

/* Number of syntax errors so far.  */
int yynerrs;


/*----------.
| yyparse.  |
`----------*/

#ifdef YYPARSE_PARAM
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void *YYPARSE_PARAM)
#else
int
yyparse (YYPARSE_PARAM)
    void *YYPARSE_PARAM;
#endif
#else /* ! YYPARSE_PARAM */
#if (defined __STDC__ || defined __C99__FUNC__ \
     || defined __cplusplus || defined _MSC_VER)
int
yyparse (void)
#else
int
yyparse ()

#endif
#endif
{
    int yystate;
    /* Number of tokens to shift before error messages enabled.  */
    int yyerrstatus;

    /* The stacks and their tools:
       `yyss': related to states.
       `yyvs': related to semantic values.

       Refer to the stacks thru separate pointers, to allow yyoverflow
       to reallocate them elsewhere.  */

    /* The state stack.  */
    yytype_int16 yyssa[YYINITDEPTH];
    yytype_int16 *yyss;
    yytype_int16 *yyssp;

    /* The semantic value stack.  */
    YYSTYPE yyvsa[YYINITDEPTH];
    YYSTYPE *yyvs;
    YYSTYPE *yyvsp;

    YYSIZE_T yystacksize;

  int yyn;
  int yyresult;
  /* Lookahead token as an internal (translated) token number.  */
  int yytoken;
  /* The variables used to return semantic value and location from the
     action routines.  */
  YYSTYPE yyval;

#if YYERROR_VERBOSE
  /* Buffer for error messages, and its allocated size.  */
  char yymsgbuf[128];
  char *yymsg = yymsgbuf;
  YYSIZE_T yymsg_alloc = sizeof yymsgbuf;
#endif

#define YYPOPSTACK(N)   (yyvsp -= (N), yyssp -= (N))

  /* The number of symbols on the RHS of the reduced rule.
     Keep to zero when no symbol should be popped.  */
  int yylen = 0;

  yytoken = 0;
  yyss = yyssa;
  yyvs = yyvsa;
  yystacksize = YYINITDEPTH;

  YYDPRINTF ((stderr, "Starting parse\n"));

  yystate = 0;
  yyerrstatus = 0;
  yynerrs = 0;
  yychar = YYEMPTY; /* Cause a token to be read.  */

  /* Initialize stack pointers.
     Waste one element of value and location stack
     so that they stay on the same level as the state stack.
     The wasted elements are never initialized.  */
  yyssp = yyss;
  yyvsp = yyvs;

  goto yysetstate;

/*------------------------------------------------------------.
| yynewstate -- Push a new state, which is found in yystate.  |
`------------------------------------------------------------*/
 yynewstate:
  /* In all cases, when you get here, the value and location stacks
     have just been pushed.  So pushing a state here evens the stacks.  */
  yyssp++;

 yysetstate:
  *yyssp = yystate;

  if (yyss + yystacksize - 1 <= yyssp)
    {
      /* Get the current used size of the three stacks, in elements.  */
      YYSIZE_T yysize = yyssp - yyss + 1;

#ifdef yyoverflow
      {
	/* Give user a chance to reallocate the stack.  Use copies of
	   these so that the &'s don't force the real ones into
	   memory.  */
	YYSTYPE *yyvs1 = yyvs;
	yytype_int16 *yyss1 = yyss;

	/* Each stack pointer address is followed by the size of the
	   data in use in that stack, in bytes.  This used to be a
	   conditional around just the two extra args, but that might
	   be undefined if yyoverflow is a macro.  */
	yyoverflow (YY_("memory exhausted"),
		    &yyss1, yysize * sizeof (*yyssp),
		    &yyvs1, yysize * sizeof (*yyvsp),
		    &yystacksize);

	yyss = yyss1;
	yyvs = yyvs1;
      }
#else /* no yyoverflow */
# ifndef YYSTACK_RELOCATE
      goto yyexhaustedlab;
# else
      /* Extend the stack our own way.  */
      if (YYMAXDEPTH <= yystacksize)
	goto yyexhaustedlab;
      yystacksize *= 2;
      if (YYMAXDEPTH < yystacksize)
	yystacksize = YYMAXDEPTH;

      {
	yytype_int16 *yyss1 = yyss;
	union yyalloc *yyptr =
	  (union yyalloc *) YYSTACK_ALLOC (YYSTACK_BYTES (yystacksize));
	if (! yyptr)
	  goto yyexhaustedlab;
	YYSTACK_RELOCATE (yyss_alloc, yyss);
	YYSTACK_RELOCATE (yyvs_alloc, yyvs);
#  undef YYSTACK_RELOCATE
	if (yyss1 != yyssa)
	  YYSTACK_FREE (yyss1);
      }
# endif
#endif /* no yyoverflow */

      yyssp = yyss + yysize - 1;
      yyvsp = yyvs + yysize - 1;

      YYDPRINTF ((stderr, "Stack size increased to %lu\n",
		  (unsigned long int) yystacksize));

      if (yyss + yystacksize - 1 <= yyssp)
	YYABORT;
    }

  YYDPRINTF ((stderr, "Entering state %d\n", yystate));

  if (yystate == YYFINAL)
    YYACCEPT;

  goto yybackup;

/*-----------.
| yybackup.  |
`-----------*/
yybackup:

  /* Do appropriate processing given the current state.  Read a
     lookahead token if we need one and don't already have one.  */

  /* First try to decide what to do without reference to lookahead token.  */
  yyn = yypact[yystate];
  if (yypact_value_is_default (yyn))
    goto yydefault;

  /* Not known => get a lookahead token if don't already have one.  */

  /* YYCHAR is either YYEMPTY or YYEOF or a valid lookahead symbol.  */
  if (yychar == YYEMPTY)
    {
      YYDPRINTF ((stderr, "Reading a token: "));
      yychar = YYLEX;
    }

  if (yychar <= YYEOF)
    {
      yychar = yytoken = YYEOF;
      YYDPRINTF ((stderr, "Now at end of input.\n"));
    }
  else
    {
      yytoken = YYTRANSLATE (yychar);
      YY_SYMBOL_PRINT ("Next token is", yytoken, &yylval, &yylloc);
    }

  /* If the proper action on seeing token YYTOKEN is to reduce or to
     detect an error, take that action.  */
  yyn += yytoken;
  if (yyn < 0 || YYLAST < yyn || yycheck[yyn] != yytoken)
    goto yydefault;
  yyn = yytable[yyn];
  if (yyn <= 0)
    {
      if (yytable_value_is_error (yyn))
        goto yyerrlab;
      yyn = -yyn;
      goto yyreduce;
    }

  /* Count tokens shifted since error; after three, turn off error
     status.  */
  if (yyerrstatus)
    yyerrstatus--;

  /* Shift the lookahead token.  */
  YY_SYMBOL_PRINT ("Shifting", yytoken, &yylval, &yylloc);

  /* Discard the shifted token.  */
  yychar = YYEMPTY;

  yystate = yyn;
  *++yyvsp = yylval;

  goto yynewstate;


/*-----------------------------------------------------------.
| yydefault -- do the default action for the current state.  |
`-----------------------------------------------------------*/
yydefault:
  yyn = yydefact[yystate];
  if (yyn == 0)
    goto yyerrlab;
  goto yyreduce;


/*-----------------------------.
| yyreduce -- Do a reduction.  |
`-----------------------------*/
yyreduce:
  /* yyn is the number of a rule to reduce with.  */
  yylen = yyr2[yyn];

  /* If YYLEN is nonzero, implement the default value of the action:
     `$$ = $1'.

     Otherwise, the following line sets YYVAL to garbage.
     This behavior is undocumented and Bison
     users should not rely upon it.  Assigning to YYVAL
     unconditionally makes the parser a bit smaller, and it avoids a
     GCC warning that YYVAL may be used uninitialized.  */
  yyval = yyvsp[1-yylen];


  YY_REDUCE_PRINT (yyn);
  switch (yyn)
    {
        case 4:

/* Line 1806 of yacc.c  */
#line 158 "policy_parse.y"
    { if (define_policy(pass, 0) == -1) return -1; }
    break;

  case 5:

/* Line 1806 of yacc.c  */
#line 160 "policy_parse.y"
    { if (pass == 1) { if (policydb_index_classes(policydbp)) return -1; }
                            else if (pass == 2) { if (policydb_index_others(NULL, policydbp, 0)) return -1; }}
    break;

  case 6:

/* Line 1806 of yacc.c  */
#line 163 "policy_parse.y"
    { if (pass == 1) { if (policydb_index_bools(policydbp)) return -1;}
			   else if (pass == 2) { if (policydb_index_others(NULL, policydbp, 0)) return -1;}}
    break;

  case 10:

/* Line 1806 of yacc.c  */
#line 171 "policy_parse.y"
    {if (define_class()) return -1;}
    break;

  case 13:

/* Line 1806 of yacc.c  */
#line 177 "policy_parse.y"
    {if (define_initial_sid()) return -1;}
    break;

  case 19:

/* Line 1806 of yacc.c  */
#line 188 "policy_parse.y"
    {if (define_common_perms()) return -1;}
    break;

  case 22:

/* Line 1806 of yacc.c  */
#line 194 "policy_parse.y"
    {if (define_av_perms(FALSE)) return -1;}
    break;

  case 23:

/* Line 1806 of yacc.c  */
#line 196 "policy_parse.y"
    {if (define_av_perms(TRUE)) return -1;}
    break;

  case 24:

/* Line 1806 of yacc.c  */
#line 198 "policy_parse.y"
    {if (define_av_perms(TRUE)) return -1;}
    break;

  case 33:

/* Line 1806 of yacc.c  */
#line 211 "policy_parse.y"
    {if (define_default_user(DEFAULT_SOURCE)) return -1; }
    break;

  case 34:

/* Line 1806 of yacc.c  */
#line 213 "policy_parse.y"
    {if (define_default_user(DEFAULT_TARGET)) return -1; }
    break;

  case 35:

/* Line 1806 of yacc.c  */
#line 216 "policy_parse.y"
    {if (define_default_role(DEFAULT_SOURCE)) return -1; }
    break;

  case 36:

/* Line 1806 of yacc.c  */
#line 218 "policy_parse.y"
    {if (define_default_role(DEFAULT_TARGET)) return -1; }
    break;

  case 37:

/* Line 1806 of yacc.c  */
#line 221 "policy_parse.y"
    {if (define_default_range(DEFAULT_SOURCE_LOW)) return -1; }
    break;

  case 38:

/* Line 1806 of yacc.c  */
#line 223 "policy_parse.y"
    {if (define_default_range(DEFAULT_SOURCE_HIGH)) return -1; }
    break;

  case 39:

/* Line 1806 of yacc.c  */
#line 225 "policy_parse.y"
    {if (define_default_range(DEFAULT_SOURCE_LOW_HIGH)) return -1; }
    break;

  case 40:

/* Line 1806 of yacc.c  */
#line 227 "policy_parse.y"
    {if (define_default_range(DEFAULT_TARGET_LOW)) return -1; }
    break;

  case 41:

/* Line 1806 of yacc.c  */
#line 229 "policy_parse.y"
    {if (define_default_range(DEFAULT_TARGET_HIGH)) return -1; }
    break;

  case 42:

/* Line 1806 of yacc.c  */
#line 231 "policy_parse.y"
    {if (define_default_range(DEFAULT_TARGET_LOW_HIGH)) return -1; }
    break;

  case 48:

/* Line 1806 of yacc.c  */
#line 242 "policy_parse.y"
    {if (define_sens()) return -1;}
    break;

  case 49:

/* Line 1806 of yacc.c  */
#line 244 "policy_parse.y"
    {if (define_sens()) return -1;}
    break;

  case 51:

/* Line 1806 of yacc.c  */
#line 249 "policy_parse.y"
    {if (define_dominance()) return -1;}
    break;

  case 52:

/* Line 1806 of yacc.c  */
#line 251 "policy_parse.y"
    {if (define_dominance()) return -1;}
    break;

  case 57:

/* Line 1806 of yacc.c  */
#line 260 "policy_parse.y"
    {if (define_category()) return -1;}
    break;

  case 58:

/* Line 1806 of yacc.c  */
#line 262 "policy_parse.y"
    {if (define_category()) return -1;}
    break;

  case 61:

/* Line 1806 of yacc.c  */
#line 268 "policy_parse.y"
    {if (define_level()) return -1;}
    break;

  case 62:

/* Line 1806 of yacc.c  */
#line 270 "policy_parse.y"
    {if (define_level()) return -1;}
    break;

  case 67:

/* Line 1806 of yacc.c  */
#line 279 "policy_parse.y"
    { if (define_constraint((constraint_expr_t*)(yyvsp[(4) - (5)].valptr))) return -1; }
    break;

  case 68:

/* Line 1806 of yacc.c  */
#line 282 "policy_parse.y"
    { if (define_validatetrans((constraint_expr_t*)(yyvsp[(3) - (4)].valptr))) return -1; }
    break;

  case 95:

/* Line 1806 of yacc.c  */
#line 315 "policy_parse.y"
    { if (define_attrib()) return -1;}
    break;

  case 96:

/* Line 1806 of yacc.c  */
#line 318 "policy_parse.y"
    {if (define_type(1)) return -1;}
    break;

  case 97:

/* Line 1806 of yacc.c  */
#line 320 "policy_parse.y"
    {if (define_type(0)) return -1;}
    break;

  case 98:

/* Line 1806 of yacc.c  */
#line 323 "policy_parse.y"
    {if (define_typealias()) return -1;}
    break;

  case 99:

/* Line 1806 of yacc.c  */
#line 326 "policy_parse.y"
    {if (define_typeattribute()) return -1;}
    break;

  case 100:

/* Line 1806 of yacc.c  */
#line 329 "policy_parse.y"
    {if (define_typebounds()) return -1;}
    break;

  case 103:

/* Line 1806 of yacc.c  */
#line 335 "policy_parse.y"
    { if (define_bool_tunable(0)) return -1; }
    break;

  case 104:

/* Line 1806 of yacc.c  */
#line 338 "policy_parse.y"
    { if (define_bool_tunable(1)) return -1; }
    break;

  case 105:

/* Line 1806 of yacc.c  */
#line 341 "policy_parse.y"
    { if (insert_id("T",0)) return -1; }
    break;

  case 106:

/* Line 1806 of yacc.c  */
#line 343 "policy_parse.y"
    { if (insert_id("F",0)) return -1; }
    break;

  case 107:

/* Line 1806 of yacc.c  */
#line 346 "policy_parse.y"
    { if (pass == 2) { if (define_conditional((cond_expr_t*)(yyvsp[(2) - (6)].ptr), (avrule_t*)(yyvsp[(4) - (6)].ptr), (avrule_t*)(yyvsp[(6) - (6)].ptr)) < 0) return -1;  }}
    break;

  case 108:

/* Line 1806 of yacc.c  */
#line 349 "policy_parse.y"
    { (yyval.ptr) = (yyvsp[(3) - (4)].ptr); }
    break;

  case 109:

/* Line 1806 of yacc.c  */
#line 351 "policy_parse.y"
    { (yyval.ptr) = NULL; }
    break;

  case 110:

/* Line 1806 of yacc.c  */
#line 353 "policy_parse.y"
    { (yyval.ptr) = (yyvsp[(2) - (3)].ptr);}
    break;

  case 111:

/* Line 1806 of yacc.c  */
#line 355 "policy_parse.y"
    { (yyval.ptr) = define_cond_expr(COND_NOT, (yyvsp[(2) - (2)].ptr), 0);
			  if ((yyval.ptr) == 0) return -1; }
    break;

  case 112:

/* Line 1806 of yacc.c  */
#line 358 "policy_parse.y"
    { (yyval.ptr) = define_cond_expr(COND_AND, (yyvsp[(1) - (3)].ptr), (yyvsp[(3) - (3)].ptr));
			  if ((yyval.ptr) == 0) return  -1; }
    break;

  case 113:

/* Line 1806 of yacc.c  */
#line 361 "policy_parse.y"
    { (yyval.ptr) = define_cond_expr(COND_OR, (yyvsp[(1) - (3)].ptr), (yyvsp[(3) - (3)].ptr));
			  if ((yyval.ptr) == 0) return   -1; }
    break;

  case 114:

/* Line 1806 of yacc.c  */
#line 364 "policy_parse.y"
    { (yyval.ptr) = define_cond_expr(COND_XOR, (yyvsp[(1) - (3)].ptr), (yyvsp[(3) - (3)].ptr));
			  if ((yyval.ptr) == 0) return  -1; }
    break;

  case 115:

/* Line 1806 of yacc.c  */
#line 367 "policy_parse.y"
    { (yyval.ptr) = define_cond_expr(COND_EQ, (yyvsp[(1) - (3)].ptr), (yyvsp[(3) - (3)].ptr));
			  if ((yyval.ptr) == 0) return  -1; }
    break;

  case 116:

/* Line 1806 of yacc.c  */
#line 370 "policy_parse.y"
    { (yyval.ptr) = define_cond_expr(COND_NEQ, (yyvsp[(1) - (3)].ptr), (yyvsp[(3) - (3)].ptr));
			  if ((yyval.ptr) == 0) return  -1; }
    break;

  case 117:

/* Line 1806 of yacc.c  */
#line 373 "policy_parse.y"
    { (yyval.ptr) = (yyvsp[(1) - (1)].ptr); }
    break;

  case 118:

/* Line 1806 of yacc.c  */
#line 376 "policy_parse.y"
    { (yyval.ptr) = define_cond_expr(COND_BOOL,0, 0);
			  if ((yyval.ptr) == COND_ERR) return   -1; }
    break;

  case 119:

/* Line 1806 of yacc.c  */
#line 380 "policy_parse.y"
    { (yyval.ptr) = define_cond_pol_list((avrule_t *)(yyvsp[(1) - (2)].ptr), (avrule_t *)(yyvsp[(2) - (2)].ptr)); }
    break;

  case 120:

/* Line 1806 of yacc.c  */
#line 382 "policy_parse.y"
    { (yyval.ptr) = NULL; }
    break;

  case 121:

/* Line 1806 of yacc.c  */
#line 385 "policy_parse.y"
    { (yyval.ptr) = (yyvsp[(1) - (1)].ptr); }
    break;

  case 122:

/* Line 1806 of yacc.c  */
#line 387 "policy_parse.y"
    { (yyval.ptr) = (yyvsp[(1) - (1)].ptr); }
    break;

  case 123:

/* Line 1806 of yacc.c  */
#line 389 "policy_parse.y"
    { (yyval.ptr) = NULL; }
    break;

  case 124:

/* Line 1806 of yacc.c  */
#line 392 "policy_parse.y"
    { (yyval.ptr) = define_cond_filename_trans() ;
                          if ((yyval.ptr) == COND_ERR) return -1;}
    break;

  case 125:

/* Line 1806 of yacc.c  */
#line 395 "policy_parse.y"
    { (yyval.ptr) = define_cond_compute_type(AVRULE_TRANSITION) ;
                          if ((yyval.ptr) == COND_ERR) return -1;}
    break;

  case 126:

/* Line 1806 of yacc.c  */
#line 398 "policy_parse.y"
    { (yyval.ptr) = define_cond_compute_type(AVRULE_MEMBER) ;
                          if ((yyval.ptr) ==  COND_ERR) return -1;}
    break;

  case 127:

/* Line 1806 of yacc.c  */
#line 401 "policy_parse.y"
    { (yyval.ptr) = define_cond_compute_type(AVRULE_CHANGE) ;
                          if ((yyval.ptr) == COND_ERR) return -1;}
    break;

  case 128:

/* Line 1806 of yacc.c  */
#line 405 "policy_parse.y"
    { (yyval.ptr) = (yyvsp[(1) - (1)].ptr); }
    break;

  case 129:

/* Line 1806 of yacc.c  */
#line 407 "policy_parse.y"
    { (yyval.ptr) = (yyvsp[(1) - (1)].ptr); }
    break;

  case 130:

/* Line 1806 of yacc.c  */
#line 409 "policy_parse.y"
    { (yyval.ptr) = (yyvsp[(1) - (1)].ptr); }
    break;

  case 131:

/* Line 1806 of yacc.c  */
#line 411 "policy_parse.y"
    { (yyval.ptr) = (yyvsp[(1) - (1)].ptr); }
    break;

  case 132:

/* Line 1806 of yacc.c  */
#line 414 "policy_parse.y"
    { (yyval.ptr) = define_cond_te_avtab(AVRULE_ALLOWED) ;
                          if ((yyval.ptr) == COND_ERR) return -1; }
    break;

  case 133:

/* Line 1806 of yacc.c  */
#line 418 "policy_parse.y"
    { (yyval.ptr) = define_cond_te_avtab(AVRULE_AUDITALLOW) ;
                          if ((yyval.ptr) == COND_ERR) return -1; }
    break;

  case 134:

/* Line 1806 of yacc.c  */
#line 422 "policy_parse.y"
    { (yyval.ptr) = define_cond_te_avtab(AVRULE_AUDITDENY) ;
                          if ((yyval.ptr) == COND_ERR) return -1; }
    break;

  case 135:

/* Line 1806 of yacc.c  */
#line 426 "policy_parse.y"
    { (yyval.ptr) = define_cond_te_avtab(AVRULE_DONTAUDIT);
                          if ((yyval.ptr) == COND_ERR) return -1; }
    break;

  case 136:

/* Line 1806 of yacc.c  */
#line 431 "policy_parse.y"
    {if (define_filename_trans()) return -1; }
    break;

  case 137:

/* Line 1806 of yacc.c  */
#line 433 "policy_parse.y"
    {if (define_compute_type(AVRULE_TRANSITION)) return -1;}
    break;

  case 138:

/* Line 1806 of yacc.c  */
#line 435 "policy_parse.y"
    {if (define_compute_type(AVRULE_MEMBER)) return -1;}
    break;

  case 139:

/* Line 1806 of yacc.c  */
#line 437 "policy_parse.y"
    {if (define_compute_type(AVRULE_CHANGE)) return -1;}
    break;

  case 140:

/* Line 1806 of yacc.c  */
#line 440 "policy_parse.y"
    { if (define_range_trans(0)) return -1; }
    break;

  case 141:

/* Line 1806 of yacc.c  */
#line 442 "policy_parse.y"
    { if (define_range_trans(1)) return -1; }
    break;

  case 147:

/* Line 1806 of yacc.c  */
#line 451 "policy_parse.y"
    {if (define_te_avtab(AVRULE_ALLOWED)) return -1; }
    break;

  case 148:

/* Line 1806 of yacc.c  */
#line 454 "policy_parse.y"
    {if (define_te_avtab(AVRULE_AUDITALLOW)) return -1; }
    break;

  case 149:

/* Line 1806 of yacc.c  */
#line 457 "policy_parse.y"
    {if (define_te_avtab(AVRULE_AUDITDENY)) return -1; }
    break;

  case 150:

/* Line 1806 of yacc.c  */
#line 460 "policy_parse.y"
    {if (define_te_avtab(AVRULE_DONTAUDIT)) return -1; }
    break;

  case 151:

/* Line 1806 of yacc.c  */
#line 463 "policy_parse.y"
    {if (define_te_avtab(AVRULE_NEVERALLOW)) return -1; }
    break;

  case 152:

/* Line 1806 of yacc.c  */
#line 466 "policy_parse.y"
    {if (define_attrib_role()) return -1; }
    break;

  case 153:

/* Line 1806 of yacc.c  */
#line 469 "policy_parse.y"
    {if (define_role_types()) return -1;}
    break;

  case 154:

/* Line 1806 of yacc.c  */
#line 472 "policy_parse.y"
    {if (define_role_attr()) return -1;}
    break;

  case 156:

/* Line 1806 of yacc.c  */
#line 477 "policy_parse.y"
    {if (define_role_trans(0)) return -1; }
    break;

  case 157:

/* Line 1806 of yacc.c  */
#line 479 "policy_parse.y"
    {if (define_role_trans(1)) return -1;}
    break;

  case 158:

/* Line 1806 of yacc.c  */
#line 482 "policy_parse.y"
    {if (define_role_allow()) return -1; }
    break;

  case 159:

/* Line 1806 of yacc.c  */
#line 485 "policy_parse.y"
    { (yyval.ptr) = (yyvsp[(1) - (1)].ptr); }
    break;

  case 160:

/* Line 1806 of yacc.c  */
#line 487 "policy_parse.y"
    { (yyval.ptr) = merge_roles_dom((role_datum_t*)(yyvsp[(1) - (2)].ptr), (role_datum_t*)(yyvsp[(2) - (2)].ptr)); if ((yyval.ptr) == 0) return -1;}
    break;

  case 161:

/* Line 1806 of yacc.c  */
#line 490 "policy_parse.y"
    {(yyval.ptr) = define_role_dom(NULL); if ((yyval.ptr) == 0) return -1;}
    break;

  case 162:

/* Line 1806 of yacc.c  */
#line 492 "policy_parse.y"
    {(yyval.ptr) = define_role_dom((role_datum_t*)(yyvsp[(4) - (5)].ptr)); if ((yyval.ptr) == 0) return -1;}
    break;

  case 163:

/* Line 1806 of yacc.c  */
#line 495 "policy_parse.y"
    {if (define_roleattribute()) return -1;}
    break;

  case 170:

/* Line 1806 of yacc.c  */
#line 507 "policy_parse.y"
    { if (define_constraint((constraint_expr_t*)(yyvsp[(4) - (5)].valptr))) return -1; }
    break;

  case 171:

/* Line 1806 of yacc.c  */
#line 510 "policy_parse.y"
    { if (define_validatetrans((constraint_expr_t*)(yyvsp[(3) - (4)].valptr))) return -1; }
    break;

  case 172:

/* Line 1806 of yacc.c  */
#line 513 "policy_parse.y"
    { (yyval.valptr) = (yyvsp[(2) - (3)].valptr); }
    break;

  case 173:

/* Line 1806 of yacc.c  */
#line 515 "policy_parse.y"
    { (yyval.valptr) = define_cexpr(CEXPR_NOT, (yyvsp[(2) - (2)].valptr), 0);
			  if ((yyval.valptr) == 0) return -1; }
    break;

  case 174:

/* Line 1806 of yacc.c  */
#line 518 "policy_parse.y"
    { (yyval.valptr) = define_cexpr(CEXPR_AND, (yyvsp[(1) - (3)].valptr), (yyvsp[(3) - (3)].valptr));
			  if ((yyval.valptr) == 0) return -1; }
    break;

  case 175:

/* Line 1806 of yacc.c  */
#line 521 "policy_parse.y"
    { (yyval.valptr) = define_cexpr(CEXPR_OR, (yyvsp[(1) - (3)].valptr), (yyvsp[(3) - (3)].valptr));
			  if ((yyval.valptr) == 0) return -1; }
    break;

  case 176:

/* Line 1806 of yacc.c  */
#line 524 "policy_parse.y"
    { (yyval.valptr) = (yyvsp[(1) - (1)].valptr); }
    break;

  case 177:

/* Line 1806 of yacc.c  */
#line 527 "policy_parse.y"
    { (yyval.valptr) = define_cexpr(CEXPR_ATTR, CEXPR_USER, (yyvsp[(2) - (3)].valptr));
			  if ((yyval.valptr) == 0) return -1; }
    break;

  case 178:

/* Line 1806 of yacc.c  */
#line 530 "policy_parse.y"
    { (yyval.valptr) = define_cexpr(CEXPR_ATTR, CEXPR_ROLE, (yyvsp[(2) - (3)].valptr));
			  if ((yyval.valptr) == 0) return -1; }
    break;

  case 179:

/* Line 1806 of yacc.c  */
#line 533 "policy_parse.y"
    { (yyval.valptr) = define_cexpr(CEXPR_ATTR, CEXPR_TYPE, (yyvsp[(2) - (3)].valptr));
			  if ((yyval.valptr) == 0) return -1; }
    break;

  case 180:

/* Line 1806 of yacc.c  */
#line 535 "policy_parse.y"
    { if (insert_separator(1)) return -1; }
    break;

  case 181:

/* Line 1806 of yacc.c  */
#line 536 "policy_parse.y"
    { (yyval.valptr) = define_cexpr(CEXPR_NAMES, CEXPR_USER, (yyvsp[(2) - (4)].valptr));
			  if ((yyval.valptr) == 0) return -1; }
    break;

  case 182:

/* Line 1806 of yacc.c  */
#line 538 "policy_parse.y"
    { if (insert_separator(1)) return -1; }
    break;

  case 183:

/* Line 1806 of yacc.c  */
#line 539 "policy_parse.y"
    { (yyval.valptr) = define_cexpr(CEXPR_NAMES, (CEXPR_USER | CEXPR_TARGET), (yyvsp[(2) - (4)].valptr));
			  if ((yyval.valptr) == 0) return -1; }
    break;

  case 184:

/* Line 1806 of yacc.c  */
#line 541 "policy_parse.y"
    { if (insert_separator(1)) return -1; }
    break;

  case 185:

/* Line 1806 of yacc.c  */
#line 542 "policy_parse.y"
    { (yyval.valptr) = define_cexpr(CEXPR_NAMES, (CEXPR_USER | CEXPR_XTARGET), (yyvsp[(2) - (4)].valptr));
			  if ((yyval.valptr) == 0) return -1; }
    break;

  case 186:

/* Line 1806 of yacc.c  */
#line 544 "policy_parse.y"
    { if (insert_separator(1)) return -1; }
    break;

  case 187:

/* Line 1806 of yacc.c  */
#line 545 "policy_parse.y"
    { (yyval.valptr) = define_cexpr(CEXPR_NAMES, CEXPR_ROLE, (yyvsp[(2) - (4)].valptr));
			  if ((yyval.valptr) == 0) return -1; }
    break;

  case 188:

/* Line 1806 of yacc.c  */
#line 547 "policy_parse.y"
    { if (insert_separator(1)) return -1; }
    break;

  case 189:

/* Line 1806 of yacc.c  */
#line 548 "policy_parse.y"
    { (yyval.valptr) = define_cexpr(CEXPR_NAMES, (CEXPR_ROLE | CEXPR_TARGET), (yyvsp[(2) - (4)].valptr));
			  if ((yyval.valptr) == 0) return -1; }
    break;

  case 190:

/* Line 1806 of yacc.c  */
#line 550 "policy_parse.y"
    { if (insert_separator(1)) return -1; }
    break;

  case 191:

/* Line 1806 of yacc.c  */
#line 551 "policy_parse.y"
    { (yyval.valptr) = define_cexpr(CEXPR_NAMES, (CEXPR_ROLE | CEXPR_XTARGET), (yyvsp[(2) - (4)].valptr));
			  if ((yyval.valptr) == 0) return -1; }
    break;

  case 192:

/* Line 1806 of yacc.c  */
#line 553 "policy_parse.y"
    { if (insert_separator(1)) return -1; }
    break;

  case 193:

/* Line 1806 of yacc.c  */
#line 554 "policy_parse.y"
    { (yyval.valptr) = define_cexpr(CEXPR_NAMES, CEXPR_TYPE, (yyvsp[(2) - (4)].valptr));
			  if ((yyval.valptr) == 0) return -1; }
    break;

  case 194:

/* Line 1806 of yacc.c  */
#line 556 "policy_parse.y"
    { if (insert_separator(1)) return -1; }
    break;

  case 195:

/* Line 1806 of yacc.c  */
#line 557 "policy_parse.y"
    { (yyval.valptr) = define_cexpr(CEXPR_NAMES, (CEXPR_TYPE | CEXPR_TARGET), (yyvsp[(2) - (4)].valptr));
			  if ((yyval.valptr) == 0) return -1; }
    break;

  case 196:

/* Line 1806 of yacc.c  */
#line 559 "policy_parse.y"
    { if (insert_separator(1)) return -1; }
    break;

  case 197:

/* Line 1806 of yacc.c  */
#line 560 "policy_parse.y"
    { (yyval.valptr) = define_cexpr(CEXPR_NAMES, (CEXPR_TYPE | CEXPR_XTARGET), (yyvsp[(2) - (4)].valptr));
			  if ((yyval.valptr) == 0) return -1; }
    break;

  case 198:

/* Line 1806 of yacc.c  */
#line 563 "policy_parse.y"
    { (yyval.valptr) = define_cexpr(CEXPR_ATTR, CEXPR_USER, CEXPR_EQ);
			  if ((yyval.valptr) == 0) return -1; }
    break;

  case 199:

/* Line 1806 of yacc.c  */
#line 565 "policy_parse.y"
    { if (insert_separator(1)) return -1; }
    break;

  case 200:

/* Line 1806 of yacc.c  */
#line 566 "policy_parse.y"
    { (yyval.valptr) = define_cexpr(CEXPR_NAMES, CEXPR_ROLE, CEXPR_EQ);
			  if ((yyval.valptr) == 0) return -1; }
    break;

  case 201:

/* Line 1806 of yacc.c  */
#line 568 "policy_parse.y"
    { if (insert_separator(1)) return -1; }
    break;

  case 202:

/* Line 1806 of yacc.c  */
#line 569 "policy_parse.y"
    { (yyval.valptr) = define_cexpr(CEXPR_NAMES, (CEXPR_ROLE | CEXPR_TARGET), CEXPR_EQ);
			  if ((yyval.valptr) == 0) return -1; }
    break;

  case 203:

/* Line 1806 of yacc.c  */
#line 572 "policy_parse.y"
    { (yyval.valptr) = define_cexpr(CEXPR_ATTR, CEXPR_ROLE, (yyvsp[(2) - (2)].valptr));
			  if ((yyval.valptr) == 0) return -1; }
    break;

  case 204:

/* Line 1806 of yacc.c  */
#line 574 "policy_parse.y"
    { if (insert_separator(1)) return -1; }
    break;

  case 205:

/* Line 1806 of yacc.c  */
#line 575 "policy_parse.y"
    { (yyval.valptr) = define_cexpr(CEXPR_NAMES, CEXPR_TYPE, CEXPR_EQ);
			  if ((yyval.valptr) == 0) return -1; }
    break;

  case 206:

/* Line 1806 of yacc.c  */
#line 577 "policy_parse.y"
    { if (insert_separator(1)) return -1; }
    break;

  case 207:

/* Line 1806 of yacc.c  */
#line 578 "policy_parse.y"
    { (yyval.valptr) = define_cexpr(CEXPR_NAMES, (CEXPR_TYPE | CEXPR_TARGET), CEXPR_EQ);
			  if ((yyval.valptr) == 0) return -1; }
    break;

  case 208:

/* Line 1806 of yacc.c  */
#line 581 "policy_parse.y"
    { (yyval.valptr) = define_cexpr(CEXPR_ATTR, CEXPR_L1L2, (yyvsp[(2) - (3)].valptr));
			  if ((yyval.valptr) == 0) return -1; }
    break;

  case 209:

/* Line 1806 of yacc.c  */
#line 584 "policy_parse.y"
    { (yyval.valptr) = define_cexpr(CEXPR_ATTR, CEXPR_L1H2, (yyvsp[(2) - (3)].valptr));
			  if ((yyval.valptr) == 0) return -1; }
    break;

  case 210:

/* Line 1806 of yacc.c  */
#line 587 "policy_parse.y"
    { (yyval.valptr) = define_cexpr(CEXPR_ATTR, CEXPR_H1L2, (yyvsp[(2) - (3)].valptr));
			  if ((yyval.valptr) == 0) return -1; }
    break;

  case 211:

/* Line 1806 of yacc.c  */
#line 590 "policy_parse.y"
    { (yyval.valptr) = define_cexpr(CEXPR_ATTR, CEXPR_H1H2, (yyvsp[(2) - (3)].valptr));
			  if ((yyval.valptr) == 0) return -1; }
    break;

  case 212:

/* Line 1806 of yacc.c  */
#line 593 "policy_parse.y"
    { (yyval.valptr) = define_cexpr(CEXPR_ATTR, CEXPR_L1H1, (yyvsp[(2) - (3)].valptr));
			  if ((yyval.valptr) == 0) return -1; }
    break;

  case 213:

/* Line 1806 of yacc.c  */
#line 596 "policy_parse.y"
    { (yyval.valptr) = define_cexpr(CEXPR_ATTR, CEXPR_L2H2, (yyvsp[(2) - (3)].valptr));
			  if ((yyval.valptr) == 0) return -1; }
    break;

  case 214:

/* Line 1806 of yacc.c  */
#line 600 "policy_parse.y"
    { (yyval.valptr) = CEXPR_EQ; }
    break;

  case 215:

/* Line 1806 of yacc.c  */
#line 602 "policy_parse.y"
    { (yyval.valptr) = CEXPR_NEQ; }
    break;

  case 216:

/* Line 1806 of yacc.c  */
#line 605 "policy_parse.y"
    { (yyval.valptr) = (yyvsp[(1) - (1)].valptr); }
    break;

  case 217:

/* Line 1806 of yacc.c  */
#line 607 "policy_parse.y"
    { (yyval.valptr) = CEXPR_DOM; }
    break;

  case 218:

/* Line 1806 of yacc.c  */
#line 609 "policy_parse.y"
    { (yyval.valptr) = CEXPR_DOMBY; }
    break;

  case 219:

/* Line 1806 of yacc.c  */
#line 611 "policy_parse.y"
    { (yyval.valptr) = CEXPR_INCOMP; }
    break;

  case 222:

/* Line 1806 of yacc.c  */
#line 617 "policy_parse.y"
    {if (define_user()) return -1;}
    break;

  case 227:

/* Line 1806 of yacc.c  */
#line 626 "policy_parse.y"
    {if (define_initial_sid_context()) return -1;}
    break;

  case 236:

/* Line 1806 of yacc.c  */
#line 639 "policy_parse.y"
    {if (define_pirq_context((yyvsp[(2) - (3)].val))) return -1;}
    break;

  case 237:

/* Line 1806 of yacc.c  */
#line 642 "policy_parse.y"
    {if (define_iomem_context((yyvsp[(2) - (3)].val),(yyvsp[(2) - (3)].val))) return -1;}
    break;

  case 238:

/* Line 1806 of yacc.c  */
#line 644 "policy_parse.y"
    {if (define_iomem_context((yyvsp[(2) - (5)].val),(yyvsp[(4) - (5)].val))) return -1;}
    break;

  case 239:

/* Line 1806 of yacc.c  */
#line 647 "policy_parse.y"
    {if (define_ioport_context((yyvsp[(2) - (3)].val),(yyvsp[(2) - (3)].val))) return -1;}
    break;

  case 240:

/* Line 1806 of yacc.c  */
#line 649 "policy_parse.y"
    {if (define_ioport_context((yyvsp[(2) - (5)].val),(yyvsp[(4) - (5)].val))) return -1;}
    break;

  case 241:

/* Line 1806 of yacc.c  */
#line 652 "policy_parse.y"
    {if (define_pcidevice_context((yyvsp[(2) - (3)].val))) return -1;}
    break;

  case 246:

/* Line 1806 of yacc.c  */
#line 661 "policy_parse.y"
    {if (define_fs_context((yyvsp[(2) - (5)].val),(yyvsp[(3) - (5)].val))) return -1;}
    break;

  case 252:

/* Line 1806 of yacc.c  */
#line 672 "policy_parse.y"
    {if (define_port_context((yyvsp[(3) - (4)].val),(yyvsp[(3) - (4)].val))) return -1;}
    break;

  case 253:

/* Line 1806 of yacc.c  */
#line 674 "policy_parse.y"
    {if (define_port_context((yyvsp[(3) - (6)].val),(yyvsp[(5) - (6)].val))) return -1;}
    break;

  case 258:

/* Line 1806 of yacc.c  */
#line 683 "policy_parse.y"
    {if (define_netif_context()) return -1;}
    break;

  case 263:

/* Line 1806 of yacc.c  */
#line 692 "policy_parse.y"
    {if (define_ipv4_node_context()) return -1;}
    break;

  case 264:

/* Line 1806 of yacc.c  */
#line 694 "policy_parse.y"
    {if (define_ipv6_node_context()) return -1;}
    break;

  case 269:

/* Line 1806 of yacc.c  */
#line 703 "policy_parse.y"
    {if (define_fs_use(SECURITY_FS_USE_XATTR)) return -1;}
    break;

  case 270:

/* Line 1806 of yacc.c  */
#line 705 "policy_parse.y"
    {if (define_fs_use(SECURITY_FS_USE_TASK)) return -1;}
    break;

  case 271:

/* Line 1806 of yacc.c  */
#line 707 "policy_parse.y"
    {if (define_fs_use(SECURITY_FS_USE_TRANS)) return -1;}
    break;

  case 276:

/* Line 1806 of yacc.c  */
#line 716 "policy_parse.y"
    {if (define_genfs_context(1)) return -1;}
    break;

  case 277:

/* Line 1806 of yacc.c  */
#line 717 "policy_parse.y"
    {insert_id("-", 0);}
    break;

  case 278:

/* Line 1806 of yacc.c  */
#line 718 "policy_parse.y"
    {if (define_genfs_context(1)) return -1;}
    break;

  case 279:

/* Line 1806 of yacc.c  */
#line 720 "policy_parse.y"
    {if (define_genfs_context(0)) return -1;}
    break;

  case 280:

/* Line 1806 of yacc.c  */
#line 723 "policy_parse.y"
    { if (insert_id(yytext,0)) return -1; }
    break;

  case 284:

/* Line 1806 of yacc.c  */
#line 731 "policy_parse.y"
    {if (insert_separator(0)) return -1;}
    break;

  case 285:

/* Line 1806 of yacc.c  */
#line 733 "policy_parse.y"
    {if (insert_separator(0)) return -1;}
    break;

  case 286:

/* Line 1806 of yacc.c  */
#line 736 "policy_parse.y"
    {if (insert_separator(0)) return -1;}
    break;

  case 287:

/* Line 1806 of yacc.c  */
#line 738 "policy_parse.y"
    {if (insert_separator(0)) return -1;}
    break;

  case 292:

/* Line 1806 of yacc.c  */
#line 748 "policy_parse.y"
    { if (insert_separator(0)) return -1; }
    break;

  case 293:

/* Line 1806 of yacc.c  */
#line 750 "policy_parse.y"
    { if (insert_separator(0)) return -1; }
    break;

  case 294:

/* Line 1806 of yacc.c  */
#line 752 "policy_parse.y"
    { if (insert_id("*", 0)) return -1; 
			  if (insert_separator(0)) return -1; }
    break;

  case 295:

/* Line 1806 of yacc.c  */
#line 755 "policy_parse.y"
    { if (insert_id("~", 0)) return -1;
			  if (insert_separator(0)) return -1; }
    break;

  case 296:

/* Line 1806 of yacc.c  */
#line 758 "policy_parse.y"
    { if (insert_id("~", 0)) return -1; 
			  if (insert_separator(0)) return -1; }
    break;

  case 297:

/* Line 1806 of yacc.c  */
#line 760 "policy_parse.y"
    { if (insert_id("-", 0)) return -1; }
    break;

  case 298:

/* Line 1806 of yacc.c  */
#line 761 "policy_parse.y"
    { if (insert_separator(0)) return -1; }
    break;

  case 299:

/* Line 1806 of yacc.c  */
#line 764 "policy_parse.y"
    { if (insert_id("~", 1)) return -1; }
    break;

  case 300:

/* Line 1806 of yacc.c  */
#line 767 "policy_parse.y"
    { if (insert_id("*", 1)) return -1; }
    break;

  case 308:

/* Line 1806 of yacc.c  */
#line 779 "policy_parse.y"
    { if (insert_id(yytext, 1)) return -1; }
    break;

  case 315:

/* Line 1806 of yacc.c  */
#line 788 "policy_parse.y"
    { if (insert_id("-", 0)) return -1; }
    break;

  case 318:

/* Line 1806 of yacc.c  */
#line 791 "policy_parse.y"
    { if (insert_id(yytext,0)) return -1; }
    break;

  case 319:

/* Line 1806 of yacc.c  */
#line 794 "policy_parse.y"
    { if (insert_id(yytext,0)) return -1; }
    break;

  case 320:

/* Line 1806 of yacc.c  */
#line 796 "policy_parse.y"
    { if (insert_id(yytext,0)) return -1; }
    break;

  case 321:

/* Line 1806 of yacc.c  */
#line 799 "policy_parse.y"
    { if (insert_id(yytext,0)) return -1; }
    break;

  case 322:

/* Line 1806 of yacc.c  */
#line 802 "policy_parse.y"
    { yytext[strlen(yytext) - 1] = '\0'; if (insert_id(yytext + 1,0)) return -1; }
    break;

  case 323:

/* Line 1806 of yacc.c  */
#line 805 "policy_parse.y"
    { (yyval.val) = strtoul(yytext,NULL,0); }
    break;

  case 324:

/* Line 1806 of yacc.c  */
#line 808 "policy_parse.y"
    { if (insert_id(yytext,0)) return -1; }
    break;

  case 325:

/* Line 1806 of yacc.c  */
#line 811 "policy_parse.y"
    {if (define_polcap()) return -1;}
    break;

  case 326:

/* Line 1806 of yacc.c  */
#line 814 "policy_parse.y"
    {if (define_permissive()) return -1;}
    break;

  case 327:

/* Line 1806 of yacc.c  */
#line 819 "policy_parse.y"
    { if (end_avrule_block(pass) == -1) return -1;
                          if (policydb_index_others(NULL, policydbp, 0)) return -1;
                        }
    break;

  case 328:

/* Line 1806 of yacc.c  */
#line 824 "policy_parse.y"
    { if (define_policy(pass, 1) == -1) return -1; }
    break;

  case 329:

/* Line 1806 of yacc.c  */
#line 827 "policy_parse.y"
    { if (insert_id(yytext,0)) return -1; }
    break;

  case 330:

/* Line 1806 of yacc.c  */
#line 829 "policy_parse.y"
    { if (insert_id(yytext,0)) return -1; }
    break;

  case 346:

/* Line 1806 of yacc.c  */
#line 853 "policy_parse.y"
    { if (require_class(pass)) return -1; }
    break;

  case 347:

/* Line 1806 of yacc.c  */
#line 855 "policy_parse.y"
    { (yyval.require_func) = require_role; }
    break;

  case 348:

/* Line 1806 of yacc.c  */
#line 856 "policy_parse.y"
    { (yyval.require_func) = require_type; }
    break;

  case 349:

/* Line 1806 of yacc.c  */
#line 857 "policy_parse.y"
    { (yyval.require_func) = require_attribute; }
    break;

  case 350:

/* Line 1806 of yacc.c  */
#line 858 "policy_parse.y"
    { (yyval.require_func) = require_attribute_role; }
    break;

  case 351:

/* Line 1806 of yacc.c  */
#line 859 "policy_parse.y"
    { (yyval.require_func) = require_user; }
    break;

  case 352:

/* Line 1806 of yacc.c  */
#line 860 "policy_parse.y"
    { (yyval.require_func) = require_bool; }
    break;

  case 353:

/* Line 1806 of yacc.c  */
#line 861 "policy_parse.y"
    { (yyval.require_func) = require_tunable; }
    break;

  case 354:

/* Line 1806 of yacc.c  */
#line 862 "policy_parse.y"
    { (yyval.require_func) = require_sens; }
    break;

  case 355:

/* Line 1806 of yacc.c  */
#line 863 "policy_parse.y"
    { (yyval.require_func) = require_cat; }
    break;

  case 356:

/* Line 1806 of yacc.c  */
#line 866 "policy_parse.y"
    { if ((yyvsp[(0) - (1)].require_func) (pass)) return -1; }
    break;

  case 357:

/* Line 1806 of yacc.c  */
#line 868 "policy_parse.y"
    { if ((yyvsp[(0) - (3)].require_func) (pass)) return -1; }
    break;

  case 358:

/* Line 1806 of yacc.c  */
#line 871 "policy_parse.y"
    { if (end_avrule_block(pass) == -1) return -1; }
    break;

  case 359:

/* Line 1806 of yacc.c  */
#line 873 "policy_parse.y"
    { if (end_optional(pass) == -1) return -1; }
    break;

  case 360:

/* Line 1806 of yacc.c  */
#line 876 "policy_parse.y"
    { if (end_avrule_block(pass) == -1) return -1; }
    break;

  case 362:

/* Line 1806 of yacc.c  */
#line 880 "policy_parse.y"
    { if (begin_optional(pass) == -1) return -1; }
    break;

  case 363:

/* Line 1806 of yacc.c  */
#line 883 "policy_parse.y"
    { if (begin_optional_else(pass) == -1) return -1; }
    break;



/* Line 1806 of yacc.c  */
#line 3867 "y.tab.c"
      default: break;
    }
  /* User semantic actions sometimes alter yychar, and that requires
     that yytoken be updated with the new translation.  We take the
     approach of translating immediately before every use of yytoken.
     One alternative is translating here after every semantic action,
     but that translation would be missed if the semantic action invokes
     YYABORT, YYACCEPT, or YYERROR immediately after altering yychar or
     if it invokes YYBACKUP.  In the case of YYABORT or YYACCEPT, an
     incorrect destructor might then be invoked immediately.  In the
     case of YYERROR or YYBACKUP, subsequent parser actions might lead
     to an incorrect destructor call or verbose syntax error message
     before the lookahead is translated.  */
  YY_SYMBOL_PRINT ("-> $$ =", yyr1[yyn], &yyval, &yyloc);

  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);

  *++yyvsp = yyval;

  /* Now `shift' the result of the reduction.  Determine what state
     that goes to, based on the state we popped back to and the rule
     number reduced by.  */

  yyn = yyr1[yyn];

  yystate = yypgoto[yyn - YYNTOKENS] + *yyssp;
  if (0 <= yystate && yystate <= YYLAST && yycheck[yystate] == *yyssp)
    yystate = yytable[yystate];
  else
    yystate = yydefgoto[yyn - YYNTOKENS];

  goto yynewstate;


/*------------------------------------.
| yyerrlab -- here on detecting error |
`------------------------------------*/
yyerrlab:
  /* Make sure we have latest lookahead translation.  See comments at
     user semantic actions for why this is necessary.  */
  yytoken = yychar == YYEMPTY ? YYEMPTY : YYTRANSLATE (yychar);

  /* If not already recovering from an error, report this error.  */
  if (!yyerrstatus)
    {
      ++yynerrs;
#if ! YYERROR_VERBOSE
      yyerror (YY_("syntax error"));
#else
# define YYSYNTAX_ERROR yysyntax_error (&yymsg_alloc, &yymsg, \
                                        yyssp, yytoken)
      {
        char const *yymsgp = YY_("syntax error");
        int yysyntax_error_status;
        yysyntax_error_status = YYSYNTAX_ERROR;
        if (yysyntax_error_status == 0)
          yymsgp = yymsg;
        else if (yysyntax_error_status == 1)
          {
            if (yymsg != yymsgbuf)
              YYSTACK_FREE (yymsg);
            yymsg = (char *) YYSTACK_ALLOC (yymsg_alloc);
            if (!yymsg)
              {
                yymsg = yymsgbuf;
                yymsg_alloc = sizeof yymsgbuf;
                yysyntax_error_status = 2;
              }
            else
              {
                yysyntax_error_status = YYSYNTAX_ERROR;
                yymsgp = yymsg;
              }
          }
        yyerror (yymsgp);
        if (yysyntax_error_status == 2)
          goto yyexhaustedlab;
      }
# undef YYSYNTAX_ERROR
#endif
    }



  if (yyerrstatus == 3)
    {
      /* If just tried and failed to reuse lookahead token after an
	 error, discard it.  */

      if (yychar <= YYEOF)
	{
	  /* Return failure if at end of input.  */
	  if (yychar == YYEOF)
	    YYABORT;
	}
      else
	{
	  yydestruct ("Error: discarding",
		      yytoken, &yylval);
	  yychar = YYEMPTY;
	}
    }

  /* Else will try to reuse lookahead token after shifting the error
     token.  */
  goto yyerrlab1;


/*---------------------------------------------------.
| yyerrorlab -- error raised explicitly by YYERROR.  |
`---------------------------------------------------*/
yyerrorlab:

  /* Pacify compilers like GCC when the user code never invokes
     YYERROR and the label yyerrorlab therefore never appears in user
     code.  */
  if (/*CONSTCOND*/ 0)
     goto yyerrorlab;

  /* Do not reclaim the symbols of the rule which action triggered
     this YYERROR.  */
  YYPOPSTACK (yylen);
  yylen = 0;
  YY_STACK_PRINT (yyss, yyssp);
  yystate = *yyssp;
  goto yyerrlab1;


/*-------------------------------------------------------------.
| yyerrlab1 -- common code for both syntax error and YYERROR.  |
`-------------------------------------------------------------*/
yyerrlab1:
  yyerrstatus = 3;	/* Each real token shifted decrements this.  */

  for (;;)
    {
      yyn = yypact[yystate];
      if (!yypact_value_is_default (yyn))
	{
	  yyn += YYTERROR;
	  if (0 <= yyn && yyn <= YYLAST && yycheck[yyn] == YYTERROR)
	    {
	      yyn = yytable[yyn];
	      if (0 < yyn)
		break;
	    }
	}

      /* Pop the current state because it cannot handle the error token.  */
      if (yyssp == yyss)
	YYABORT;


      yydestruct ("Error: popping",
		  yystos[yystate], yyvsp);
      YYPOPSTACK (1);
      yystate = *yyssp;
      YY_STACK_PRINT (yyss, yyssp);
    }

  *++yyvsp = yylval;


  /* Shift the error token.  */
  YY_SYMBOL_PRINT ("Shifting", yystos[yyn], yyvsp, yylsp);

  yystate = yyn;
  goto yynewstate;


/*-------------------------------------.
| yyacceptlab -- YYACCEPT comes here.  |
`-------------------------------------*/
yyacceptlab:
  yyresult = 0;
  goto yyreturn;

/*-----------------------------------.
| yyabortlab -- YYABORT comes here.  |
`-----------------------------------*/
yyabortlab:
  yyresult = 1;
  goto yyreturn;

#if !defined(yyoverflow) || YYERROR_VERBOSE
/*-------------------------------------------------.
| yyexhaustedlab -- memory exhaustion comes here.  |
`-------------------------------------------------*/
yyexhaustedlab:
  yyerror (YY_("memory exhausted"));
  yyresult = 2;
  /* Fall through.  */
#endif

yyreturn:
  if (yychar != YYEMPTY)
    {
      /* Make sure we have latest lookahead translation.  See comments at
         user semantic actions for why this is necessary.  */
      yytoken = YYTRANSLATE (yychar);
      yydestruct ("Cleanup: discarding lookahead",
                  yytoken, &yylval);
    }
  /* Do not reclaim the symbols of the rule which action triggered
     this YYABORT or YYACCEPT.  */
  YYPOPSTACK (yylen);
  YY_STACK_PRINT (yyss, yyssp);
  while (yyssp != yyss)
    {
      yydestruct ("Cleanup: popping",
		  yystos[*yyssp], yyvsp);
      YYPOPSTACK (1);
    }
#ifndef yyoverflow
  if (yyss != yyssa)
    YYSTACK_FREE (yyss);
#endif
#if YYERROR_VERBOSE
  if (yymsg != yymsgbuf)
    YYSTACK_FREE (yymsg);
#endif
  /* Make sure YYID is used.  */
  return YYID (yyresult);
}



